-- ********************************************************************
--
-- Copyright 2005-2008 Synplicity, Inc.  All rights reserved.
-- This code was generated by Synplicity's Synplify DSP product and
-- is intended for use solely by licensed users of this product.

-- VHDL created by Synplify DSP 3.6, Build 188R, Apr  7 2008
-- Date written:             Mon Nov 10 08:39:24 2008

-- ********************************************************************
library ieee;
use ieee.std_logic_1164.all;

entity clock_gen is
generic(
  cperiod: delay_length := 20 ns;
  rperiod: delay_length := 100 ns
);
port(
  halt: in boolean;
  clk: out std_logic;
  rst: out std_logic
);
end clock_gen;

architecture behav of clock_gen is
begin
  assert rperiod >= 3*cperiod/2
    report "E@: rperiod should be greater than 3*cperiod/2"
    severity Error;
  rst <= '1', '0' after rperiod;  
  cgen: process
  begin
    clk <= '0', '1' after cperiod/2, '0' after cperiod, '1' after 3*cperiod/2;
    wait for rperiod;
    loop
     if (halt=true) then 
       wait;
     else
       clk <= '1', '0' after cperiod/2;
       wait for cperiod;
     end if; 
    end loop;
  end process;
end behav;
------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
entity clocks is
generic(
  cperiod: delay_length := 20 ns;
  rperiod: delay_length := 100 ns
);
port(
  halt: in boolean;
  clk: out std_logic;
  rst: out std_logic
);
end clocks;
architecture behav of clocks is
signal clk_loc, rst_loc: std_logic;
component clock_gen
generic(
  cperiod: delay_length := 20 ns;
  rperiod: delay_length := 100 ns
);
port(
  halt: in boolean;
  rst: out std_logic;
  clk: out std_logic
);
end component;
begin
  rst <= rst_loc;
  clk <= clk_loc;
  cgen: clock_gen generic map (cperiod =>cperiod, rperiod =>rperiod) 
  port map(halt=>halt, clk=>clk_loc, rst=>rst_loc); 
end behav;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use std.textio.all;
use IEEE.std_logic_textio.all;

entity test_Ripac_EdgeDetection_HW_Detect6_unit8 is
end test_Ripac_EdgeDetection_HW_Detect6_unit8;

architecture beh of test_Ripac_EdgeDetection_HW_Detect6_unit8 is

component Ripac_EdgeDetection_HW_Detect6_unit8
port (
  clk : in std_logic;
  GlobalReset : in std_logic;
  GlobalEnable1 :  in std_logic;
  HW_Edge_Detector1_Sobel_V :  out std_logic_vector(8 downto 0); -- sfix9_En0
  HW_Edge_Detector1_Sobel_H :  out std_logic_vector(8 downto 0); -- sfix9_En0
  HW_Edge_Detector1_Line_2_out :  out std_logic_vector(7 downto 0); -- ufix8_En0
  HW_Edge_Detector1_Line_1_out :  out std_logic_vector(7 downto 0); -- ufix8_En0
  HW_Edge_Detector1_Data_out :  out std_logic_vector(17 downto 0); -- sfix18_En0
  HW_Edge_Detector1_Data_in :  in std_logic_vector(7 downto 0) -- ufix8_En0
);
--
end component; 

component clocks
generic(
  cperiod: delay_length := 20 ns;
  rperiod: delay_length := 100 ns
);
port(
  halt: in boolean;
  clk: out std_logic;
  rst: out std_logic
);
end component;
file logFile: text open write_mode is"simlog.txt";
file HW_Edge_Detector1_Sobel_VRefFile: text open read_mode is"Outport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Sobel_V.dat";
file HW_Edge_Detector1_Sobel_VOutFile: text open write_mode is"Simout_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Sobel_V.dat";
file HW_Edge_Detector1_Sobel_HRefFile: text open read_mode is"Outport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Sobel_H.dat";
file HW_Edge_Detector1_Sobel_HOutFile: text open write_mode is"Simout_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Sobel_H.dat";
file HW_Edge_Detector1_Line_2_outRefFile: text open read_mode is"Outport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Line_2_out.dat";
file HW_Edge_Detector1_Line_2_outOutFile: text open write_mode is"Simout_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Line_2_out.dat";
file HW_Edge_Detector1_Line_1_outRefFile: text open read_mode is"Outport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Line_1_out.dat";
file HW_Edge_Detector1_Line_1_outOutFile: text open write_mode is"Simout_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Line_1_out.dat";
file HW_Edge_Detector1_Data_outRefFile: text open read_mode is"Outport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Data_out.dat";
file HW_Edge_Detector1_Data_outOutFile: text open write_mode is"Simout_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Data_out.dat";
file HW_Edge_Detector1_Data_inFile: text open read_mode is"Inport_Ripac_EdgeDetection_HW_Detect6_unit8_HW_Edge_Detector1_Data_in.dat";
signal isNotFirstRise1 : boolean := false;

signal isSimulationEnd : boolean := false;
signal isSimulationEnd1 : boolean := false;

signal mismatch : integer;
signal mismatch1 : integer := 0;
signal loop_cnt1 : integer := 0;

signal clk_int : std_logic := '1';
signal GlobalReset_int : std_logic := '0';
signal GlobalEnable1_int: std_logic_vector(0 downto 0);
signal HW_Edge_Detector1_Sobel_V_int: std_logic_vector(8 downto 0);
signal HW_Edge_Detector1_Sobel_H_int: std_logic_vector(8 downto 0);
signal HW_Edge_Detector1_Line_2_out_int: std_logic_vector(7 downto 0);
signal HW_Edge_Detector1_Line_1_out_int: std_logic_vector(7 downto 0);
signal HW_Edge_Detector1_Data_out_int: std_logic_vector(17 downto 0);
signal HW_Edge_Detector1_Data_in_int: std_logic_vector(7 downto 0);
begin
 --Instantiate design under test
i_Ripac_EdgeDetection_HW_Detect6_unit8: Ripac_EdgeDetection_HW_Detect6_unit8 port map (
    clk => clk_int,
    GlobalReset => GlobalReset_int,
    GlobalEnable1 => GlobalEnable1_int(0),
    HW_Edge_Detector1_Sobel_V => HW_Edge_Detector1_Sobel_V_int,
    HW_Edge_Detector1_Sobel_H => HW_Edge_Detector1_Sobel_H_int,
    HW_Edge_Detector1_Line_2_out => HW_Edge_Detector1_Line_2_out_int,
    HW_Edge_Detector1_Line_1_out => HW_Edge_Detector1_Line_1_out_int,
    HW_Edge_Detector1_Data_out => HW_Edge_Detector1_Data_out_int,
    HW_Edge_Detector1_Data_in => HW_Edge_Detector1_Data_in_int
  );
CL: clocks
generic map(cperiod=>974658 ns, rperiod=>9746580 ns)
port map (
  halt => isSimulationEnd,
  clk => clk_int,
  rst => GlobalReset_int
  );

  GlobalEnable1_int(0) <= NOT(GlobalReset_int);
  isSimulationEnd <= isSimulationEnd1;

  mismatch <= mismatch1;
  FirstRiseProc1: process(clk_int) begin
    if(rising_edge(clk_int)) then
      isNotFirstRise1 <= true;
    end if;
  end process;
  ------------------------------------------------------------
  -- Process for Rate Domain of clk 
  -- Inputs are applied on rising edge of clock, 
  -- Outputs are tested on rising edges.
  ------------------------------------------------------------
  vec_tst1: process(clk_int)
    variable ErrorMsgLine : line;
    variable VectorLine : line;
    variable OutLine : line;
    variable VectorValid : boolean;
    variable misFlg : boolean;
      variable tmp_HW_Edge_Detector1_Sobel_V: std_logic_vector(8 downto 0);
      variable ref_HW_Edge_Detector1_Sobel_V: std_logic_vector(8 downto 0);
      variable tmp_HW_Edge_Detector1_Sobel_H: std_logic_vector(8 downto 0);
      variable ref_HW_Edge_Detector1_Sobel_H: std_logic_vector(8 downto 0);
      variable tmp_HW_Edge_Detector1_Line_2_out: std_logic_vector(7 downto 0);
      variable ref_HW_Edge_Detector1_Line_2_out: std_logic_vector(7 downto 0);
      variable tmp_HW_Edge_Detector1_Line_1_out: std_logic_vector(7 downto 0);
      variable ref_HW_Edge_Detector1_Line_1_out: std_logic_vector(7 downto 0);
      variable tmp_HW_Edge_Detector1_Data_out: std_logic_vector(17 downto 0);
      variable ref_HW_Edge_Detector1_Data_out: std_logic_vector(17 downto 0);
      variable tmp_HW_Edge_Detector1_Data_in: std_logic_vector(7 downto 0);
  begin
    misFlg := FALSE;

-- Apply Input Vectors -----
  if (rising_edge(clk_int)) then
    if (isNotFirstRise1) then
      if (endfile(HW_Edge_Detector1_Data_inFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Data_inFile, VectorLine);
        read(VectorLine, tmp_HW_Edge_Detector1_Data_in, good => VectorValid);
        HW_Edge_Detector1_Data_in_int <= tmp_HW_Edge_Detector1_Data_in;
      end if;
    end if;
  end if;

  if (rising_edge(clk_int) and (GlobalReset_int='0'))then
    if(loop_cnt1 >= 0) then
      if (endfile(HW_Edge_Detector1_Sobel_VRefFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Sobel_VRefFile, VectorLine);
        read(VectorLine, ref_HW_Edge_Detector1_Sobel_V, good => VectorValid);

        tmp_HW_Edge_Detector1_Sobel_V := HW_Edge_Detector1_Sobel_V_int;

        write(OutLine, tmp_HW_Edge_Detector1_Sobel_V);
        writeline(HW_Edge_Detector1_Sobel_VOutFile, OutLine);

      end if;
      if(not(tmp_HW_Edge_Detector1_Sobel_V = ref_HW_Edge_Detector1_Sobel_V)) then
        misFlg := TRUE;
        write(OutLine, string'("Vector failed for port: HW_Edge_Detector1_Sobel_V"));        writeline(logFile, OutLine);
        write(OutLine, string'("Expecting: "));        write(OutLine, ref_HW_Edge_Detector1_Sobel_V);        writeline(logFile, OutLine);
        write(OutLine, string'("Actual:    "));        write(OutLine, tmp_HW_Edge_Detector1_Sobel_V);        writeline(logFile, OutLine);
      end if;

      if (endfile(HW_Edge_Detector1_Sobel_HRefFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Sobel_HRefFile, VectorLine);
        read(VectorLine, ref_HW_Edge_Detector1_Sobel_H, good => VectorValid);

        tmp_HW_Edge_Detector1_Sobel_H := HW_Edge_Detector1_Sobel_H_int;

        write(OutLine, tmp_HW_Edge_Detector1_Sobel_H);
        writeline(HW_Edge_Detector1_Sobel_HOutFile, OutLine);

      end if;
      if(not(tmp_HW_Edge_Detector1_Sobel_H = ref_HW_Edge_Detector1_Sobel_H)) then
        misFlg := TRUE;
        write(OutLine, string'("Vector failed for port: HW_Edge_Detector1_Sobel_H"));        writeline(logFile, OutLine);
        write(OutLine, string'("Expecting: "));        write(OutLine, ref_HW_Edge_Detector1_Sobel_H);        writeline(logFile, OutLine);
        write(OutLine, string'("Actual:    "));        write(OutLine, tmp_HW_Edge_Detector1_Sobel_H);        writeline(logFile, OutLine);
      end if;

      if (endfile(HW_Edge_Detector1_Line_2_outRefFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Line_2_outRefFile, VectorLine);
        read(VectorLine, ref_HW_Edge_Detector1_Line_2_out, good => VectorValid);

        tmp_HW_Edge_Detector1_Line_2_out := HW_Edge_Detector1_Line_2_out_int;

        write(OutLine, tmp_HW_Edge_Detector1_Line_2_out);
        writeline(HW_Edge_Detector1_Line_2_outOutFile, OutLine);

      end if;
      if(not(tmp_HW_Edge_Detector1_Line_2_out = ref_HW_Edge_Detector1_Line_2_out)) then
        misFlg := TRUE;
        write(OutLine, string'("Vector failed for port: HW_Edge_Detector1_Line_2_out"));        writeline(logFile, OutLine);
        write(OutLine, string'("Expecting: "));        write(OutLine, ref_HW_Edge_Detector1_Line_2_out);        writeline(logFile, OutLine);
        write(OutLine, string'("Actual:    "));        write(OutLine, tmp_HW_Edge_Detector1_Line_2_out);        writeline(logFile, OutLine);
      end if;

      if (endfile(HW_Edge_Detector1_Line_1_outRefFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Line_1_outRefFile, VectorLine);
        read(VectorLine, ref_HW_Edge_Detector1_Line_1_out, good => VectorValid);

        tmp_HW_Edge_Detector1_Line_1_out := HW_Edge_Detector1_Line_1_out_int;

        write(OutLine, tmp_HW_Edge_Detector1_Line_1_out);
        writeline(HW_Edge_Detector1_Line_1_outOutFile, OutLine);

      end if;
      if(not(tmp_HW_Edge_Detector1_Line_1_out = ref_HW_Edge_Detector1_Line_1_out)) then
        misFlg := TRUE;
        write(OutLine, string'("Vector failed for port: HW_Edge_Detector1_Line_1_out"));        writeline(logFile, OutLine);
        write(OutLine, string'("Expecting: "));        write(OutLine, ref_HW_Edge_Detector1_Line_1_out);        writeline(logFile, OutLine);
        write(OutLine, string'("Actual:    "));        write(OutLine, tmp_HW_Edge_Detector1_Line_1_out);        writeline(logFile, OutLine);
      end if;

      if (endfile(HW_Edge_Detector1_Data_outRefFile)) then
        isSimulationEnd1 <= true;
      else 
        readline(HW_Edge_Detector1_Data_outRefFile, VectorLine);
        read(VectorLine, ref_HW_Edge_Detector1_Data_out, good => VectorValid);

        tmp_HW_Edge_Detector1_Data_out := HW_Edge_Detector1_Data_out_int;

        write(OutLine, tmp_HW_Edge_Detector1_Data_out);
        writeline(HW_Edge_Detector1_Data_outOutFile, OutLine);

      end if;
      if(not(tmp_HW_Edge_Detector1_Data_out = ref_HW_Edge_Detector1_Data_out)) then
        misFlg := TRUE;
        write(OutLine, string'("Vector failed for port: HW_Edge_Detector1_Data_out"));        writeline(logFile, OutLine);
        write(OutLine, string'("Expecting: "));        write(OutLine, ref_HW_Edge_Detector1_Data_out);        writeline(logFile, OutLine);
        write(OutLine, string'("Actual:    "));        write(OutLine, tmp_HW_Edge_Detector1_Data_out);        writeline(logFile, OutLine);
      end if;

      if(misFlg) then
        mismatch1 <= mismatch1 + 1;
        write(OutLine,  string'("Mismatch at clk cycle no "));
        write(OutLine, loop_cnt1);
        writeline(logFile, OutLine);
        write(OutLine, string'("-----------------------------"));
        writeline(logFile, OutLine);
      end if;
    end if;

    loop_cnt1 <= loop_cnt1 + 1;
  end if;
    end process;

------------------------------------------------------------
-- Print Final Simulation Summary --
------------------------------------------------------------
  EndSimulation: process(isSimulationEnd)
    variable ErrorMsgLine : line;
    variable VectorLine : line;
    variable VectorValid : boolean;
    variable OutLine : line;
    begin
    if (isSimulationEnd) then
      write(ErrorMsgLine, string'("End Simulation"));
      writeline(output, ErrorMsgLine);
      if(mismatch = 0) then
        write(OutLine,  string'(" *******  VHDL Verification Successful! ******* "));
        writeline(logFile, OutLine);
        write(OutLine,  string'("No extra latency"));
        report" No extra latency " severity note;
        writeline(logFile, OutLine);
        report" *******  VHDL Verification Successful! ******* " severity note;
      else
        write(OutLine,  string'("Failed with "));
        write(OutLine, mismatch);
        write(OutLine,  string'(" mismatches"));
        writeline(logFile, OutLine);
        report" ******* VHDL Verification Failed! ******* " severity error;
        report" Failed with " & integer'image(mismatch) & " mismatches";
      end if;
    end if;
  end process; --Simulation End

end beh;
