
#ifndef UNI1P_ACCESS
#define UNI1P_ACCESS

#include "../lib/p9054_lib.h"

#define UNI1P_VID               0x10b5
#define UNI1P_DID               0x9054


#define ADDR_SPACE_MASK         0xfff00000
// CPLD register's addresses
#define CPLD_ADDR_SPACE         P9054_ADDR_SPACE0
#define CPLD_BASE_ADDR          0xe0000000
// FPGA register's addresses
#define FPGA_ADDR_SPACE         P9054_ADDR_SPACE1
#define FPGA_BASE_ADDR          0x10000000
#define MASTER_BASE_ADDR        0x10080000

#define REG_MASK                0xffff

// SMAP registers
#define SYSTEM_SMAP_STAT        0x10000080
#define SYSTEM_SMAP_DATA        0x10000084
// HPI registers
#define SYSTEM_HPI_STAT         0x10000040
#define SYSTEM_HPI_CTRL         0x10000044
#define SYSTEM_HPI_ADDR         0x10000048
#define SYSTEM_HPI_LEN          0x1000004C
#define SYSTEM_HPI_DATA         0x10000050

#define SYSTEM_DMA0_ADDR        0x10000004
#define SYSTEM_DMA0_LEN         0x10000008
#define SYSTEM_DMA0_CTRL        0x1000000C

// added by DZ
#define MASTER_DMA0_ADDR        0x10080004
#define MASTER_DMA0_LEN         0x10080008
#define MASTER_DMA0_CTRL        0x1008000C
#define CPLD_CONFIG				0xE0000000
#define CPLD_SMAP				0xE0000008
// moje registry, MASTER, DEVICE_2
#define DZ_REGA					0x10080080
#define DZ_REGB					0x10080084
#define DZ_SUMB					0x10080088
#define DZ_REGE					0x10080090
#define DZ_REGF					0x10080094
#define DZ_REGG					0x10080098
#define DZ_REGH					0x1008009C


// bitove vahy
#define	B0		0x00000001
#define	B1		0x00000002
#define	B2		0x00000004
#define	B3		0x00000008
#define	B4		0x00000010
#define	B5		0x00000020
#define	B6		0x00000040
#define	B7		0x00000080
#define	B8		0x00000100
#define	B9		0x00000200
#define	B10		0x00000400
#define	B11		0x00000800
#define	B12		0x00001000
#define	B13		0x00002000
#define	B14		0x00004000
#define	B15		0x00008000
#define	B16		0x00010000
#define	B17		0x00020000
#define	B18		0x00040000
#define	B19		0x00080000
#define	B20		0x00100000
#define	B21		0x00200000
#define	B22		0x00400000
#define	B23		0x00800000
#define	B24		0x01000000
#define	B25		0x02000000
#define	B26		0x04000000
#define	B27		0x08000000
#define	B28		0x10000000
#define	B29		0x20000000
#define	B30		0x40000000
#define	B31		0x80000000



P9054_HANDLE PLX_LocateAndOpenBoard(DWORD dwVendorID, DWORD dwDeviceID);

void WriteDWord(P9054_HANDLE hPlx, DWORD addr, DWORD data);
void WriteByte(P9054_HANDLE hPlx, DWORD addr, BYTE data);
DWORD ReadDWord(P9054_HANDLE hPlx, DWORD addr);
BYTE ReadByte(P9054_HANDLE hPlx, DWORD addr);

DWORD GetValue( char *str );

// standart access
int Normal( P9054_HANDLE hPlx, BOOL fIsRead, DWORD dwLocalAddr, BOOL fix_addr,
            BYTE *buf, DWORD size, P9054_MODE mode);

// DMA access
int DMA( P9054_HANDLE hPlx, BOOL fIsRead, DWORD dwLocalAddr, BOOL fix_addr,
            BYTE *buf, DWORD size, P9054_MODE mode);
/*
// DMA access
int MasterDMA( P9054_HANDLE hPlx, BOOL fIsRead, DWORD dwLocalAddr, BOOL fix_addr,
            BYTE *buf, DWORD size, P9054_MODE mode);

int MasterDMA2( P9054_HANDLE hPlx, BOOL fIsRead, DWORD dwLocalAddr, BOOL fix_addr,
            BYTE *buf, DWORD size, P9054_MODE mode, int id);
*/
// access to register of PLX
int Reg( P9054_HANDLE hPlx, BOOL fIsRead, DWORD dwLocalAddr,
            BYTE *buf, DWORD size);

#endif
 