/****************************************************************************\
 *           Copyright (C) 2000 Texas Instruments Incorporated.             *
 *                           All Rights Reserved                            *
 *                                                                          *
 * GENERAL DISCLAIMER                                                       *
 * ------------------                                                       *
 * All software and related documentation is provided "AS IS" and without   *
 * warranty or support of any kind and Texas Instruments expressly disclaims*
 * all other warranties, express or implied, including, but not limited to, *
 * the implied warranties of merchantability and fitness for a particular   *
 * purpose.  Under no circumstances shall Texas Instruments be liable for   *
 * any incidental, special or consequential damages that result from the    *
 * use or inability to use the software or related documentation, even if   *
 * Texas Instruments has been advised of the liability.                     *
 ****************************************************************************/

//This routine test de timers.
#include <csl.h>
#include <csl_timer.h>

/* Definitions */
#define PER         100

/* Global variables */
extern Int32 timer_done;
TIMER_Handle timer1;


/* Prototypes */
/*
interrupt void timer0_ISR(void);
interrupt void timer1_ISR(void);
interrupt void timer2_ISR(void);
void setTimerInterrupt(void);
Uint32 TimerTest (void);
*/



/* Timer 1 ISR used to flag when TINT0 has been received.          */
interrupt void
timer1_ISR(void)
{
	TIMER_close(timer1);
      timer_done = 1;
} /* end timer1_ISR */



/* Routine to enable DMA and Timer interrupt service routines      */
void
setTimerInterrupt(void)
{
    IRQ_enable(IRQ_EVT_TINT1);            /* Enable Timer1 -> CPU interrupt   */
    IRQ_nmiEnable();                      /* Enable non-maskable interrupt  */
    IRQ_globalEnable();                   /* Globally enable all interrupts */

} /* End setTimerInterrupt */




/* timer verification test code.                                   */
Uint32
TimerTest (void)
{
//int count   = 0;
unsigned int error = 0;
TIMER_Config TimerConfig = {   0x00000200, /* ctl - internal clock CPU/8 */
						       PER,        /* prd */
						       0x00000000  /* cnt */ };

      setTimerInterrupt();
      /* Open and Reset Timer 0/1/2 */
      timer1 = TIMER_open(TIMER_DEV1,0);
        
      TIMER_config(timer1,&TimerConfig);    
        
	  TIMER_start(timer1);
      
	  while(timer_done!=0);
	  
	  

    IRQ_disable(IRQ_EVT_TINT1);            /* Disable Timer1 -> CPU interrupt   */
    IRQ_nmiDisable();                      /* Disable non-maskable interrupt  */
    IRQ_globalDisable();                   /* Globally disable all interrupts */
    //timer_done = 0;

      return(error);      

} /* end timerTest */














