-- ********************************************************************
--
-- Copyright 2005-2008 Synplicity, Inc.  All rights reserved.
-- This code was generated by Synplicity's Synplify DSP product and
-- is intended for use solely by licensed users of this product.

-- VHDL created by Synplify DSP 3.6, Build 188R, Apr  7 2008
-- Date written:             Mon May 12 11:08:29 2008

-- ********************************************************************

-- $Header: //synplicity/dsp100dev/dsp/lib/dsp/SynLib.vhd#16 $
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package synDataTypes is
  type matrix  is array(natural range <>, natural range <>) of std_logic;
  type vecarray  is array(natural range <>) of std_logic_vector(127 downto 0);
end synDataTypes;
------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;

package synLibFunctions is
  function syn_resize(a:in signed; len: in integer) return signed;
  function syn_resize(a:in unsigned; len: in integer) return unsigned;
  function vectorize(v: std_logic_vector) return std_logic_vector;
  function vectorize(s: std_logic) return std_logic_vector;
  function scalarize(v: in std_logic_vector) return std_logic;
  function reduction_and(inp: std_logic_vector) return std_logic_vector;
  function reduction_or(inp: std_logic_vector) return std_logic_vector;
  function reduction_xor(inp: std_logic_vector) return std_logic_vector;
  function reduction_nand(inp: std_logic_vector) return std_logic_vector;
  function reduction_nor(inp: std_logic_vector) return std_logic_vector;
  function reduction_xnor(inp: std_logic_vector) return std_logic_vector;
  function expand(size: in integer; inp: in std_logic) return std_logic_vector;
  function expand(size: in integer; inp: in std_logic_vector) return std_logic_vector;
  function log_floor(num: in integer) return integer;
  function zero_bracket(num: in integer) return integer;

  component synAddSub
  generic(
    inp1_width : integer := 16;
    inp2_width : integer := 16;
    out_width: integer := 16;
    opr: string := "add";
    dataType: string := "signed"
  );
  port (
    in1:  in std_logic_vector(inp1_width-1 downto 0);
    in2:  in std_logic_vector(inp2_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;

  component synMult
  generic(
     inp1_width : integer := 16;
     inp2_width : integer := 16;
     out_width: integer := 32;
     dataType: string := "signed"
  );
  port (
    in1:  in std_logic_vector(inp1_width-1 downto 0);
    in2:  in std_logic_vector(inp2_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;

  component synBusSatRnd
  generic(
     inp_width : natural := 16;
     out_width: natural := 16;
     infrac: natural  := 0;
     outfrac: natural := 0;
     round: natural :=0;
     sat: natural :=0;
     datatype: string := "SS"
  );
  port (
    inp:  in std_logic_vector(inp_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;

  component synBusAdapter
  generic(
        inp_width : natural := 16;
   out_width: natural := 16;
   datatype: string := "signed";
   preshift: integer := 0 ;-- negative values denote left shift
   ------------------------ Arguments to sat logic
   infrac: natural  := 0;
   outfrac: natural := 0;
   rwidth:integer :=0;
   round: natural :=0;
   sat: natural :=0;
   saType: string := "SS"
  );
  port (
    inp:  in std_logic_vector(inp_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;
  
  component synNegate
  generic(
     bitwidth : integer := 16
  );
  port (
    inp: in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synInverter
  generic(
     bitwidth : integer := 16
  );
  port (
    inp: in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;


  component synGain
  generic(
     inp_width : integer := 16;
     out_width: integer := 16;
     coef_width: integer := 2;
     coefVal: std_logic_vector(127 downto 0) := std_logic_vector(to_unsigned(1,128));
     dataType: string := "signed"
  );
  port (
    inp:  in std_logic_vector(inp_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;

  component synDelay
  generic(
     bitwidth : integer := 16;
     delay: integer := 1;
     delwidth: integer := 16
  );
  port (
    clk: in std_logic;
    rst: in std_logic;
    inp:  in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synDelayWithEnable_signed
  generic(
     preferRAMImpl: integer := 1;
     bitwidth : integer := 16;
     delay: integer := 32
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    inp:  in signed(bitwidth-1 downto 0);
    outp: out signed(bitwidth-1 downto 0)
  );
  end component;

  component synDelayWithEnable_unsigned
  generic(
     preferRAMImpl: integer := 1;
     bitwidth : integer := 16;
     delay: integer := 32
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    inp:  in unsigned(bitwidth-1 downto 0);
    outp: out unsigned(bitwidth-1 downto 0)
  );
  end component;

  component synDelayWithEnable_std_logic
  generic(
     preferRAMImpl: integer := 1;
     delay: integer := 32
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    inp:  in std_logic;
    outp: out std_logic
  );
  end component;

  component synDelayWithEnable_std_logic_vector
  generic(
     preferRAMImpl: integer := 1;
     bitwidth : integer := 16;
     delay: integer := 32
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    inp:  in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synDelayWithEnableGeneric
  generic(
     preferRAMImpl: integer := 1;
     ramThreshold : integer := 68;
     decompRegs : integer := 2;
     decompThresholdMin : integer := 9;
     bitwidth : integer := 16;
     delay: integer := 32
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    inp:  in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synRobustLatch_signed
  generic(
     ch_no : integer := 1;
     bitwidth : integer := 16
  );
  port (
    clk: in std_logic;
	gEnable: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    inp:  in signed(bitwidth-1 downto 0);
    outp: out signed(bitwidth-1 downto 0)
  );
  end component;

  component synRobustLatch_unsigned
  generic(
     ch_no : integer := 1;
     bitwidth : integer := 16
  );
  port (
    clk: in std_logic;
	gEnable: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    inp:  in unsigned(bitwidth-1 downto 0);
    outp: out unsigned(bitwidth-1 downto 0)
  );
  end component;

  component synRobustLatch_std_logic
  generic(
     ch_no : integer := 1
  );
  port (
    clk: in std_logic;
	gEnable: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    inp:  in std_logic;
    outp: out std_logic
  );
  end component;

  component synRobustLatch_std_logic_vector
  generic(
     ch_no : integer := 1;
     bitwidth : integer := 16
  );
  port (
    clk: in std_logic;
	gEnable: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    inp:  in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synMux 
  generic(
    inp_width : integer := 2;
    inp_size :  integer := 3;
    sel_bits :  integer := 2
  );
  port (
    sel:  in unsigned(sel_bits-1 downto 0);
    inp:  in matrix(0 to inp_size-1, inp_width-1 downto 0);
    outp: out std_logic_vector(inp_width-1 downto 0)
  );
  end component;

  component synShifter
  generic(
     inpBitW : integer := 16;
     outBitW : integer := 16;
     shfBitW : integer := 16;
     datatype: string := "signed";
     opr: string := "<<"
  );
  port (
    inp: in std_logic_vector(inpBitW-1 downto 0);
    shf: in std_logic_vector(shfBitW-1 downto 0);
    outp: out std_logic_vector(outBitW-1 downto 0)
  );
  end component;

  component synShifterR
  generic(
     inpBitW : integer := 16;
     outBitW : integer := 16;
     shfBitW : integer := 16;
     datatype: string := "signed";
     opr: string := "<<"
  );
  port (
    inp: in std_logic_vector(inpBitW-1 downto 0);
    shf: in std_logic_vector(shfBitW-1 downto 0);
    outp: out std_logic_vector(outBitW-1 downto 0)
  );
  end component;

  component synAbs
  generic(
     bitwidth : integer := 16
  );
  port (
    inp: in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synBinLogic
  generic(
     bitwidth : integer := 16;
     opr: string := "ANDD"
  );
  port (
    inpA: in std_logic_vector(bitwidth-1 downto 0);
    inpB: in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synComparator
  generic(
     bitwidth : integer := 16;
     datatype: string := "signed";
     opr: string := "equ"
  );
  port (
    inpA: in std_logic_vector(bitwidth-1 downto 0);
    inpB: in std_logic_vector(bitwidth-1 downto 0);
    outp: out std_logic_vector(0 downto 0)
  );
  end component;

  component synCounter
  generic(
    en_exists: std_logic := '1';
    rst_exists: std_logic := '1';
    ld_exists: std_logic := '0';
    rdy_exists: std_logic := '0';
    ctype: integer := 2;
    ival: integer := 0;
    tval: integer := 127;
    bitwidth : integer := 16;
    isSigned: std_logic := '0'
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    up: in std_logic;
    ld: in std_logic;
    din: in std_logic_vector(bitwidth-1 downto 0);
    cnt: out std_logic_vector(bitwidth-1 downto 0);
    rdy: out std_logic
  );
  end component;

  component synCounterSync
  generic(
    tval: integer := 127;
	sample_offset : integer := 0;
    bitwidth: integer := 16
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rdy: out std_logic
  );
  end component;

  component synCounterFR
  generic(
    en_exists: std_logic := '1';
    rst_exists: std_logic := '1';
    ld_exists: std_logic := '0';
    ctype: integer := 2;
    ival: integer := 0;
    tval: integer := 127;
    bitwidth : integer := 16;
    isSigned: std_logic := '0'
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    up: in std_logic;
    ld: in std_logic;
    din: in std_logic_vector(bitwidth-1 downto 0);
    cnt: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synCounterMC
  generic(
    ch_no : integer := 4;
    en_exists: std_logic := '1';
    rst_exists: std_logic := '1';
    ld_exists: std_logic := '0';
    rdy_exists: std_logic := '0';
    ctype: integer := 2;
    ival: integer := 0;
    tval: integer := 127;
    bitwidth : integer := 16;
    isSigned: std_logic := '0'
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    up: in std_logic;
    ld: in std_logic;
    din: in std_logic_vector(bitwidth-1 downto 0);
    cnt: out std_logic_vector(bitwidth-1 downto 0);
    rdy: out std_logic
  );
  end component;

  component synCounterFRMC
  generic(
    ch_no : integer := 4;
    en_exists: std_logic := '1';
    rst_exists: std_logic := '1';
    ld_exists: std_logic := '0';
    ctype: integer := 2;
    ival: integer := 0;
    tval: integer := 127;
    bitwidth : integer := 16;
    isSigned: std_logic := '0'
  );
  port (
    clk: in std_logic;
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    up: in std_logic;
    ld: in std_logic;
    din: in std_logic_vector(bitwidth-1 downto 0);
    cnt: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synAccumulator
  generic(
     bitwidth : integer := 16;
     datatype: string := "signed";
     opr: string := "+="
  );
  port (
    clk: in std_logic;
    inp: in std_logic_vector(bitwidth-1 downto 0);
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synAccumulatorOvf
  generic(
     bitwidth : integer := 16;
     datatype: string := "signed";
     opr: string := "+="
  );
  port (
    clk: in std_logic;
    inp: in std_logic_vector(bitwidth-1 downto 0);
    en: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0);
    ovf: out std_logic
  );
  end component;

  component synAccumulatorMC
  generic(
    ch_no : integer := 64;
    bitwidth : integer := 16;
    datatype: string := "signed";
    opr: string := "+="
  );
  port (
    clk: in std_logic;
    inp: in std_logic_vector(bitwidth-1 downto 0);
    genab: in std_logic;
    grst: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synAccumulatorMCOvf
  generic(
    ch_no : integer := 64;
    bitwidth : integer := 16;
    datatype: string := "signed";
    opr: string := "+="
  );
  port (
    clk: in std_logic;
    inp: in std_logic_vector(bitwidth-1 downto 0);
    genab: in std_logic;
    grst: in std_logic;
    en: in std_logic;
    rst: in std_logic;
    ovf: out std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synRegister
  generic(
     bitwidth : integer := 16
  );
  port (
    clk: in std_logic;
    D: in std_logic_vector(bitwidth-1 downto 0);
    en: in std_logic;
    rst: in std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synRegisterMC
  generic(
    bitwidth : integer := 16;
    ch_no    : integer := 64
  );
  port (
    clk: in std_logic;
    D: in std_logic_vector(bitwidth-1 downto 0);
    en: in std_logic;
    rst: in std_logic;
    outp: out std_logic_vector(bitwidth-1 downto 0)
  );
  end component;

  component synFIFO
  generic(
    bitwidth : integer := 16;
    depth    : integer := 16;
    cntwidth : integer := 5;
    adrWidth : integer := 4
  );
  port (
    clk: in std_logic;
    din: in std_logic_vector(bitwidth-1 downto 0);
    we: in std_logic;
    re: in std_logic;  
    grst: in std_logic;
    rst: in std_logic;
    dout: out std_logic_vector(bitwidth-1 downto 0);
    full: out std_logic;
    empty: out std_logic;
    itemcnt: out std_logic_vector(cntwidth-1 downto 0)
  );
  end component;

  component synFIFO_MC
  generic(
    ch_no    : integer := 2;
    st_width : integer := 1;
    bitwidth : integer := 16;
    depth    : integer := 16;
    cntwidth : integer := 5;
    adrWidth : integer := 4
  );
  port (
    clk: in std_logic;
    st: in unsigned (st_width-1 downto 0);
    din: in std_logic_vector(bitwidth-1 downto 0);
    we: in std_logic;
    re: in std_logic;
    grst: in std_logic;
    rst: in std_logic;
    dout: out std_logic_vector(bitwidth-1 downto 0);
    full: out std_logic;
    empty: out std_logic;
    itemcnt: out std_logic_vector(cntwidth-1 downto 0)
  );
  end component;
  
  component synAsyncFIFO
  generic(
   bitwidth : integer := 16;
   depth    : integer := 32;
   cntwidth : integer := 6;	 -- will be adrwidth + 1 
   adrwidth : integer := 5
  );
  port (
    wclk: in std_logic;
    wge : in std_logic;  -- global enable write
    rclk: in std_logic;
    rge : in std_logic;  -- global enable read
    din: in std_logic_vector(bitwidth-1 downto 0);
    we: in std_logic;
    re: in std_logic;
    grst: in std_logic;
    dout: out std_logic_vector(bitwidth-1 downto 0);
    full: out std_logic;
    empty: out std_logic
  );
  end component;

  component synCordic 
  generic(
    m           : integer := 1;
    rotMode     : integer := 1; -- 1: rotation,    0: vectoring
    bitWidth    : integer := 16;
    angBitWidth : integer := 16;
    angFracWidth : integer := 16;
    depth       : integer := 16
    );
  port(
    clk  : in std_logic;
    rst : in std_logic;
    en  : in std_logic;
    xi  : in signed(bitWidth-1 downto 0);
    yi  : in signed(bitWidth-1 downto 0);
    zi  : in signed(angBitWidth-1 downto 0);
    xo  : out signed(bitWidth-1 downto 0);
    yo  : out signed(bitWidth-1 downto 0);
    zo  : out signed(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicMC
    generic(
      ch_no       : integer := 2;
      m           : integer := 1;
      rotMode     : integer := 1; -- 1: rotation,    0: vectoring
      bitWidth    : integer := 16;
      angBitWidth : integer := 16;
      angFracWidth : integer := 16;
      depth       : integer := 16
    );
  port(
    clk  : in std_logic;
    rst : in std_logic;
    en  : in std_logic;
    xi  : in signed(bitWidth-1 downto 0);
    yi  : in signed(bitWidth-1 downto 0);
    zi  : in signed(angBitWidth-1 downto 0);
    xo  : out signed(bitWidth-1 downto 0);
    yo  : out signed(bitWidth-1 downto 0);
    zo  : out signed(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicFolded
  generic(
    m           : integer := 1;
    rotMode     : integer := 0; -- 1: rotation,    0: vectoring
    bitWidth    : integer := 16;
    angBitWidth : integer := 16;
    angFracWidth : integer := 16;
    depth       : integer := 15;
    foFa        : integer := 15;
    cntWidth    : integer := 4
  );
  port(
    clk  : in std_logic;
    rst  : in std_logic;
    en  : in std_logic;
    xi  : in signed(bitWidth-1 downto 0);
    yi  : in signed(bitWidth-1 downto 0);
    zi  : in signed(angBitWidth-1 downto 0);
    xo  : out signed(bitWidth-1 downto 0);
    yo  : out signed(bitWidth-1 downto 0);
    zo  : out signed(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicAtan
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicAtanMC
  generic(
    ch_no       : integer := 2;
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicAtanFolded
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16;
    foFa        : integer := 15;
    cntWidth    : integer := 4
  );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicPolar
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicPolarFolded
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16;
    foFa        : integer := 15;
    cntWidth    : integer := 4
  );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicPolarMC
  generic(
    ch_no       : integer := 2;
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
  );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic;
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth-1 downto 0);
    atanOut  : out std_logic_vector(angBitWidth-1 downto 0)
  );
  end component;

  component synCordicExp
  generic(
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    mantWidth : integer := 16;
    expWidth : integer := 10
    );
  port(
    clk   : in std_logic;
    rst  : in std_logic; 
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    mantOut : out std_logic_vector(mantWidth-1 downto 0);
    expOut : out std_logic_vector(expWidth-1 downto 0)
  );
  end component;

  component synCordicExpMC
  generic(
    ch_no        : integer := 2;
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    mantWidth : integer := 16;
    expWidth : integer := 10
    );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    mantOut : out std_logic_vector(mantWidth-1 downto 0);
    expOut : out std_logic_vector(expWidth-1 downto 0)
  );
  end component;

  component synCordicExpFolded
  generic(
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    mantWidth : integer := 16;
    expWidth : integer := 10;
    foFa        : integer := 16;
    cntWidth    : integer := 4
  );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    mantOut : out std_logic_vector(mantWidth-1 downto 0);
    expOut : out std_logic_vector(expWidth-1 downto 0)
  );
  end component;

  component synCordicIntDiv  
  generic(
    bitWidth    : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic; 
    en      : in std_logic; 
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    divOut  : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicIntDivMC
  generic(
    ch_no       : integer := 2;
    bitWidth    : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic; 
    en      : in std_logic; 
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    divOut  : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicIntDivFolded
  generic(
    bitWidth    : integer := 16;
    foFa        : integer := 16;
    cntWidth    : integer := 4
  );
  port(
    clk    : in std_logic;
    rst    : in std_logic;
    en     : in std_logic; 
    x      : in std_logic_vector(bitWidth-1 downto 0);
    y      : in std_logic_vector(bitWidth-1 downto 0);
    divOut : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicVecMag
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic; 
    en      : in std_logic; 
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth downto 0)
  );
  end component;

  component synCordicVecMagMC
  generic(
    ch_no       : integer := 2;
    depth       : integer := 15;
    bitWidth    : integer := 16
   );
  port(
    clk      : in std_logic;
    rst     : in std_logic; 
    en      : in std_logic; 
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth downto 0)
  );
  end component;

  component synCordicVecMagFolded
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    foFa        : integer := 15;
    cntWidth    : integer := 4
  );
  port(
    clk      : in std_logic;
    rst     : in std_logic;
    en      : in std_logic; 
    x       : in std_logic_vector(bitWidth-1 downto 0);
    y       : in std_logic_vector(bitWidth-1 downto 0);
    magOut  : out std_logic_vector(bitWidth downto 0)
  );
  end component;

  component synCordicSinCos
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
    );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(angBitWidth-1 downto 0);
    sinout : out std_logic_vector(bitWidth-1 downto 0);
    cosout : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicSinCosMC
  generic(
    ch_no       : integer := 4;
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16
    );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(angBitWidth-1 downto 0);
    sinout : out std_logic_vector(bitWidth-1 downto 0);
    cosout : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicSinCosFolded
  generic(
    depth       : integer := 15;
    bitWidth    : integer := 16;
    angBitWidth : integer := 16;
    foFa        : integer := 15;
    cntWidth    : integer := 4
  );
  port(
    clk  : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(angBitWidth-1 downto 0);
    sinout : out std_logic_vector(bitWidth-1 downto 0);
    cosout : out std_logic_vector(bitWidth-1 downto 0)
  );
  end component;

  component synCordicLn
  generic(
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    outBitWidth : integer := 16;
    outFracWidth : integer := 8;
    depth : integer := 16;
    expWidth : integer := 5 
    );
  port(
    clk   : in std_logic;
        rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    lnOut : out std_logic_vector(outBitWidth-1 downto 0)
  );
  end component;

  component synCordicLnMC
  generic(
    ch_no       : integer := 2;
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    outBitWidth : integer := 16;
    outFracWidth : integer := 8;
    depth : integer := 16;
    expWidth : integer := 5 
    );
  port(
    clk   : in std_logic;
        rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    lnOut : out std_logic_vector(outBitWidth-1 downto 0)
  );
  end component;

  component synCordicLnFolded
  generic(
    inpBitWidth  : integer := 16;
    inpFracWidth : integer := 8;
    outBitWidth : integer := 16;
    outFracWidth : integer := 8;
    depth : integer := 16;
    expWidth : integer := 5; -- should be 2+floor(log2(max(inpBitWidth-inpFracBits, inpFracBits-1)))
    foFa        : integer := 16;
    cntWidth    : integer := 4
  );
  port(
    clk : in std_logic;
    rst : in std_logic;
    en  : in std_logic; 
    inp : in std_logic_vector(inpBitWidth-1 downto 0);
    lnOut : out std_logic_vector(outBitWidth-1 downto 0)
  );
  end component;

  component synCordicSqrt 
  generic(
    inpBitWidth  : integer := 16; -- must be an even number
    depth : integer := 16;
    expWidth : integer := 3 -- should be ceil(0.5*log2(inpBitWidth))
  );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    sqrtOut : out std_logic_vector(inpBitWidth/2 downto 0)
  );
  end component;

  component synCordicSqrtMC
  generic(
    ch_no       : integer := 2;
    inpBitWidth  : integer := 16; -- must be an even number
    depth : integer := 16;
    expWidth : integer := 3 -- should be ceil(0.5*log2(inpBitWidth))
    );
  port(
    clk   : in std_logic;
    rst  : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    sqrtOut : out std_logic_vector(inpBitWidth/2 downto 0)
  );
  end component;

  component synCordicSqrtFolded
  generic(
    inpBitWidth  : integer := 16; -- must be an even number
    depth : integer := 16;
    expWidth : integer := 3; -- should be ceil(0.5*log2(inpBitWidth))
    foFa        : integer := 16;
    cntWidth    : integer := 4
  );
  port(
    clk   : in std_logic;
    rst   : in std_logic;
    en   : in std_logic; 
    inp   : in std_logic_vector(inpBitWidth-1 downto 0);
    sqrtOut : out std_logic_vector(inpBitWidth/2 downto 0)
  );
  end component;

  component synSRL
  generic(
    bitwidth : integer := 16;
    depth : integer := 16;
    swidth : integer := 4
  );
  port (
    clk : in std_logic;
    rst : in std_logic;
    en  : in std_logic;
    Inp :   in std_logic_vector(bitwidth-1 downto 0);
    Outp :   out std_logic_vector(bitwidth-1 downto 0);
    cnt :   in unsigned(swidth-1 downto 0)
  );
  end component;

  
component synCSAUnit is
generic (bitWidth : integer := 16);
port (
	a		: in std_logic_vector(bitWidth-1 downto 0);
	b		: in std_logic_vector(bitWidth-1 downto 0);
	c		: in std_logic_vector(bitWidth-1 downto 0);
  	slow	: out std_logic_vector(bitWidth-1 downto 0);
	shigh	: out std_logic_vector(bitWidth-1 downto 0)
);
end component;

component synPipelinedAdd is
generic (bitWidth : integer := 64);
port (
 	clk		: in std_logic;
  	gReset	: in std_logic;
  	gEnable	: in std_logic;
	a		: in std_logic_vector(bitWidth-1 downto 0);
	b		: in std_logic_vector(bitWidth-1 downto 0);
  	Sum		: out std_logic_vector(bitWidth-1 downto 0)
);
end component;

end synLibFunctions;

package body synLibFunctions is
  function syn_resize(a:in signed; len: in integer) return signed is
  begin
    if a'length > len then
       return a(len-1+a'right downto a'right);
    else  
      return Resize(a,len);
    end if;  
  end syn_resize;

  function syn_resize(a:in unsigned; len: in integer) return unsigned is
  begin
    return Resize(a,len);
  end syn_resize;

  function vectorize(s: std_logic) return std_logic_vector is 
    variable v: std_logic_vector(0 downto 0); 
  begin 
    v(0) := s; 
    return v; 
  end; 

  function vectorize(v: std_logic_vector) return std_logic_vector is 
  begin 
    return v; 
  end; 

  function scalarize(v: in std_logic_vector) return std_logic is 
  begin 
    assert v'length = 1 
      report "scalarize: output port must be single bit!" 
      severity FAILURE; 
    return v(v'LEFT); 
  end; 

  function reduction_and(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) and inp(i);
    end loop;
    return outp;
  end;

  function reduction_or(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) or inp(i);
    end loop;
    return outp;
  end;

  function reduction_xor(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) xor inp(i);
    end loop;
    return outp;
  end;

  function reduction_nand(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) and inp(i);
    end loop;
    return not(outp);
  end;

  function reduction_nor(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) or inp(i);
    end loop;
    return not(outp);
  end;

  function reduction_xnor(inp: std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(0 downto 0);
  begin
    outp(0) := inp(inp'low); 
    for i in inp'high downto inp'low+1 loop
       outp(0) := outp(0) xor inp(i);
    end loop;
    return not(outp);
  end;

  function expand(size: in integer; inp: in std_logic_vector) return std_logic_vector is
  variable outp : std_logic_vector(size-1 downto 0);
  begin
    for i in size-1 downto 0 loop
      outp(i) := inp(inp'low);
    end loop;
    return outp;
  end;
 
  function expand(size: in integer; inp: in std_logic) return std_logic_vector is
  variable outp : std_logic_vector(size-1 downto 0);
  begin
    for i in size-1 downto 0 loop
      outp(i) := inp;
    end loop;
    return outp;
  end;

  function log_floor(num: in integer) return integer is
  variable temp : unsigned(31 downto 0);
  begin
    if (num = 0) then
      return 0;
    end if;
    temp := to_unsigned(num, 32);
	for i in 31 downto 0 loop
	  if(temp(i)='1') then
	    return i+1;
      end if;
	end loop;
	return -1;
  end;

  function zero_bracket(num: in integer) return integer is
  begin
    if (num > 0) then 
      return num;
    else
      return 0;  
    end if;
  end; 

end; --synLibFunctions
------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synAddSub is
generic(
   inp1_width : integer := 16;
   inp2_width : integer := 16;
   out_width: integer := 16;
   opr: string := "add";
   dataType: string := "signed"
);
port (
  in1:  in std_logic_vector(inp1_width-1 downto 0);
  in2:  in std_logic_vector(inp2_width-1 downto 0);
  outp: out std_logic_vector(out_width-1 downto 0)
);
end synAddSub;

architecture behav of synAddSub is
signal in1S: signed(out_width-1 downto 0);
signal in2S: signed(out_width-1 downto 0);
signal outpS: signed(out_width-1 downto 0);

signal in1U: unsigned(out_width-1 downto 0);
signal in2U: unsigned(out_width-1 downto 0);
signal outpU: unsigned(out_width-1 downto 0);

begin
  sig: if(dataType = "signed")
    generate
      in1S <= resize(signed(in1), out_width);
      in2S <= resize(signed(in2), out_width);
      ad: if(opr = "add")
        generate
          outpS <= resize(in1S+in2S, out_width);
        end generate;
      sub: if (opr = "sub")
        generate
          outpS <= resize(in1S-in2S, out_width);
        end generate;
      outp <= std_logic_vector(outpS);
    end generate;
  uns: if(dataType = "unsign")
    generate
      in1U <= resize(unsigned(in1), out_width);
      in2U <= resize(unsigned(in2), out_width);
      ad: if(opr = "add")
        generate
          outpU <= resize(in1U+in2U, out_width);
        end generate;
      sub: if (opr = "sub")
        generate
          outpU <= resize(in1U-in2U, out_width);
        end generate;
      outp <= std_logic_vector(outpU);
    end generate;
end behav;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synMult is
generic(
   inp1_width : integer := 16;
   inp2_width : integer := 16;
   out_width: integer := 32;
   dataType: string := "signed"
);
port (
  in1:  in std_logic_vector(inp1_width-1 downto 0);
  in2:  in std_logic_vector(inp2_width-1 downto 0);
  outp: out std_logic_vector(out_width-1 downto 0)
);
end synMult;

architecture behav of synMult is
signal in1S: signed(inp1_width-1 downto 0);
signal in2S: signed(inp2_width-1 downto 0);
signal outpS: signed(inp1_width+inp2_width-1 downto 0); -- too cautious width, but will be optimized anyway

signal in1U: unsigned(inp1_width-1 downto 0);
signal in2U: unsigned(inp2_width-1 downto 0);
signal outpU: unsigned(inp1_width+inp2_width-1 downto 0); -- too cautious width, but will be optimized anyway
begin
  sig: if(datatype="signed") 
    generate
      in1S <= signed(in1);
      in2S <= signed(in2);
      outpS <= resize(in1S*in2S, inp1_width+inp2_width);
      outp <= std_logic_vector(resize(outpS,out_width));
    end generate;

  uns: if(datatype="unsign") 
    generate
      in1U <= unsigned(in1);
      in2U <= unsigned(in2);
      outpU <= resize(in1U*in2U, inp1_width+inp2_width);
      outp <= std_logic_vector(resize(outpU,out_width));
    end generate;
end behav;

-----------------Bus Saturation-----------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


entity synBusSatRnd is
  generic(
    inp_width : natural := 16;
    out_width: natural := 16;
    infrac: natural  := 0;
    outfrac: natural := 0;
    round: natural :=0;
    sat:natural:=0;
    datatype: string := "SS" 
  );
 port (
    inp:  in std_logic_vector(inp_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
end synBusSatRnd;
architecture behav of  synBusSatRnd is
  constant inputIntWidth : integer := inp_width - infrac;
  constant outputIntWidth : integer := out_width - outfrac;
  constant doRnd : boolean := (round >= 1) and ( infrac > outfrac);
  constant doSat : boolean := (sat = 1) and 
                              ( (datatype = "SU") or 
                                  ( not(doRnd) and (datatype = "US") and (1 + inputIntWidth > outputIntWidth) ) or 
                                  ( not(doRnd) and not(datatype = "US") and (inputIntWidth > outputIntWidth) ) or
                                  ( doRnd and (datatype = "US") and (2 + inputIntWidth > outputIntWidth) ) or 
                                  ( doRnd and not(datatype = "US") and (1 + inputIntWidth > outputIntWidth) )
                              );
  constant maximumWidth : integer := inputIntWidth + outputIntWidth + infrac + outfrac + 1 + 1;
  constant shiftLeftAmount : integer := outfrac - infrac;
  constant allzero: std_logic_vector(maximumWidth - 1 downto 0):= (others => '0');
  constant allone: std_logic_vector(maximumWidth - 1 downto 0):= (others => '1');

  signal rndInput : std_logic_vector(maximumWidth - 1 downto 0);
  signal rndOutput : std_logic_vector(maximumWidth - 1 downto 0);
  signal shiftOutput : std_logic_vector(maximumWidth - 1 downto 0);

begin

  RoundInputSigned : if ( (datatype = "SU") or (datatype = "SS") ) generate
    rndInput <= std_logic_vector(resize(signed(inp), maximumWidth));
  end generate;

  RoundInputUnsigned : if ( (datatype = "UU") or (datatype = "US") ) generate
    rndInput <= std_logic_vector(resize(unsigned(inp), maximumWidth));
  end generate;

  RoundGen: if ( doRnd and (round=1 or( round=5 and (datatype="UU" or datatype = "US") )))  generate	 -- nearest round, round toward nearest (always up if equadistance)
      RoundNoShift: if( shiftLeftAmount = -1) generate
        rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(to_unsigned(1,1)));
      end generate;
      RoundShift: if( shiftLeftAmount /= -1) generate
        rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned('1' & allzero(-shiftLeftAmount - 2 downto 0)));
      end generate;
  end generate;
  
  RoundCeil: if ( doRnd and (round=4) ) generate	 -- round Ceil
        rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(allone(-shiftLeftAmount - 1 downto 0)));
  end generate;

  RoundFix: if (doRnd and (round=3) ) generate       -- round Fix(towards zero) 
     RoundSFix: if (datatype = "SU" or datatype = "SS") generate   
        rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(allone (-shiftLeftAmount - 1 downto 0) ) )
		             when rndInput( maximumWidth-1 )='1'	else
 					 std_logic_vector(unsigned(rndInput) + unsigned(allzero(-shiftLeftAmount - 1 downto 0) ) );
          end generate;
     RoundUFix : if (datatype = "UU" or datatype = "US") generate
	    rndOutput <= rndInput;
		  end generate;
  end generate;

  RoundRound: if (doRnd and (round=5 and (datatype="SU" or datatype = "SS") ) ) generate -- round matlab
    RoundNoShiftRound: if (shiftLeftAmount = -1 ) generate
	  rndOutput <= rndInput when rndInput(maximumWidth-1)='1' else
                                 std_logic_vector(unsigned(rndInput) + unsigned(to_unsigned(1,1)));
	end generate;
    RoundShiftRound: if (shiftLeftAmount /= -1 ) generate
	  rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(allone(-shiftLeftAmount - 2 downto 0))) when rndInput(maximumWidth-1)='1' else
                                 std_logic_vector(unsigned(rndInput) + unsigned('1' & allzero(-shiftLeftAmount - 2 downto 0)));
	end generate;
  end generate;

  ConvRnd: if ( doRnd and (round=2) ) generate  -- convergent round (round even if equadistance) 
  begin
    process (rndInput)
      variable fraction:  std_logic_vector(maximumWidth - 1 downto 0);
	  variable mask:  std_logic_vector(maximumWidth - 1 downto 0);
	begin
	  fraction := allzero( maximumWidth + shiftLeftAmount -1 downto 0 ) & '1' & allzero( -shiftLeftAmount  - 2 downto 0 ); 
      mask := allzero( maximumWidth + shiftLeftAmount -1 downto 0 ) & allone( -shiftLeftAmount  - 1 downto 0 ); 
	  if ( std_logic_vector (unsigned(rndInput)  and unsigned(mask) )= fraction  )then -- check equadistance 
	    rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(rndInput( -shiftLeftAmount downto -shiftLeftAmount ) & allzero( -shiftLeftAmount -2 downto 0 ) ) ); -- rndInput( 7 downto 7 ) 
      else	-- else do nearest rounding
        if( shiftLeftAmount = -1)  then
          rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned(to_unsigned(1,1)));
        end if;
        if( shiftLeftAmount /= -1)then
          rndOutput <= std_logic_vector(unsigned(rndInput) + unsigned('1' & allzero(-shiftLeftAmount - 2 downto 0)));
        end if;
      end if;
	end process	;
  end generate;
  
  RoundNotGen: if (not doRnd) generate
    rndOutput <= rndInput;
  end generate;

  ShiftGen: if ( shiftLeftAmount < 0 ) generate
    ShiftInputSigned : if ( (datatype = "SU") or (datatype = "SS") ) generate
      shiftOutput <= std_logic_vector(resize(signed(rndOutput(maximumWidth -1 downto - shiftLeftAmount)),maximumWidth));
    end generate;
    ShiftInputUnsigned : if ( (datatype = "UU") or (datatype = "US") ) generate
      shiftOutput <= std_logic_vector(resize(unsigned(rndOutput(maximumWidth -1 downto - shiftLeftAmount)),maximumWidth));
    end generate;
  end generate;
  ShiftNotGen: if ( shiftLeftAmount >= 0 ) generate
    shiftOutput <= std_logic_vector(Shift_Left(unsigned(rndOutput), shiftLeftAmount));
  end generate;

  SatNotGen: if (not doSat) generate
     outp <= shiftOutput(out_width - 1 downto 0);
  end generate;

  SatGen: if (doSat) generate
  begin
    process ( shiftOutput )
      variable satBoolean : boolean;
    begin
      if (datatype = "SS") then
        if ( shiftOutput(maximumWidth-1) = '1' ) then
          satBoolean := allone( maximumWidth-out_width-1 downto 0 ) /= shiftOutput ( maximumWidth - 2 downto out_width - 1 );
        else
          satBoolean := allzero( maximumWidth-out_width-1 downto 0 ) /= shiftOutput ( maximumWidth - 2 downto out_width - 1 );
        end if;
        
        if ( satBoolean ) then
          if (shiftOutput(maximumWidth- 1) = '1') then
            outp <= std_logic_vector( '1' & allzero(out_width - 2 downto 0) );
          else
            outp <= std_logic_vector( '0' & allone(out_width - 2 downto 0));
          end if;
        else
          outp <= shiftOutput(out_width - 1 downto 0);
        end if;
      elsif (datatype = "SU") then
        if ( allzero(maximumWidth-out_width-1 downto 0) /= shiftOutput(maximumWidth - 1 downto out_width) ) then
          if ( shiftOutput( maximumWidth- 1) = '1' ) then
            outp <= allzero(out_width-1 downto 0 );
          else
            outp <= allone(out_width-1 downto 0 );
          end if;
        else
          outp <= shiftOutput(out_width - 1 downto 0);
        end if;
      elsif (datatype = "UU") then
        if ( allzero(maximumWidth-out_width-1 downto 0) /= shiftOutput(maximumWidth - 1 downto out_width) ) then
          outp <= allone(out_width-1 downto 0);
        else
          outp <= shiftOutput(out_width - 1 downto 0);
        end if;
      elsif (datatype = "US") then
        if ( allzero(maximumWidth-out_width downto 0) /= shiftOutput(maximumWidth - 1 downto out_width - 1) ) then
          outp <= std_logic_vector('0' & allone(out_width - 2 downto 0));
        else
          outp <= shiftOutput(out_width - 1 downto 0);
        end if;
       else
         assert false 
          report "synBusSatRnd: Invalid data type." 
          severity WARNING; 	   
      end if;
    end process;
  end generate;

end behav; 

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synBusAdapter is
generic(
   inp_width : natural := 16;
   out_width: natural := 16;
   
   datatype: string := "signed";
   preshift: integer := 0; -- negative values denote left shift
   ------------------------ Arguments to sat logic
   infrac: natural  := 0;
   outfrac: natural := 0;
   rwidth:integer :=0;
   round: natural :=0;
   sat: natural :=0;
   saType: string := "SS"
);
port (
  inp:  in std_logic_vector(inp_width-1 downto 0);
  outp: out std_logic_vector(out_width-1 downto 0)
);
end synBusAdapter;

architecture behav of synBusAdapter is
 component synBusSatRnd
  generic(
     inp_width : natural := 16;
     out_width: natural := 16;   
     infrac: natural  := 0;
     outfrac: natural := 0;
     round: natural :=0;
     sat: natural :=0;
     datatype: string := "SS"
  );
  port (
    inp:  in std_logic_vector(inp_width-1 downto 0);
    outp: out std_logic_vector(out_width-1 downto 0)
  );
  end component;
  
constant tmpInpWidth : integer := inp_width + abs(preshift) + (abs(infrac-inp_width) + infrac-inp_width)/2;

signal inpS: signed(inp_width-1 downto 0);
signal inpU: unsigned(inp_width-1 downto 0);

signal shiftedInpS: signed(tmpInpWidth-1 downto 0);
signal shiftedInpU: unsigned(tmpInpWidth-1 downto 0);

begin
  sgn: if(datatype="signed") 
    generate
      inpS <= signed(inp);

      ls1: if(preshift < 0) 
        generate
          shiftedInpS <= Shift_Left(resize(inpS, tmpInpWidth), -preshift);
        end generate;

      rs1: if(preshift > 0) 
        generate
          shiftedInpS <= Shift_Right(resize(inpS, tmpInpWidth), preshift);
        end generate;

      ns1: if(preshift = 0) 
        generate
          shiftedInpS <= resize(inpS,tmpInpWidth);
        end generate;

      NOSAT:if(sat=0 and round=0) 
        generate
          outp <= std_logic_vector(syn_resize(shiftedInpS,out_width));
        end generate;

      DOSAT:if(sat=1 or round>=1) 
        generate
          Convert: synBusSatRnd
          generic map(
            inp_width => tmpInpWidth,
            out_width => out_width,
            infrac => infrac,
            outfrac =>outfrac,
            round => round,
            sat => sat,
            dataType=> saType
            )
          port map(
            inp=>std_logic_vector(shiftedInpS),
            outp=>outp
          );  
        end generate;

  end generate;--if(datatype="signed")

  uns: if(datatype="unsign") 
    generate
      inpU <= unsigned(inp);

    ls1: if(preshift < 0) 
      generate
        shiftedInpU <= Shift_Left(resize(inpU, tmpInpWidth), -preshift);
      end generate;

    rs1: if(preshift > 0) 
      generate
        shiftedInpU <= Shift_Right(resize(inpU, tmpInpWidth), preshift);
      end generate;

    ns1: if(preshift = 0) 
      generate
        shiftedInpU <= resize(inpU, tmpInpWidth);
      end generate;

    NOSAT:if(sat=0 and round=0) 
      generate
        outp <= std_logic_vector(syn_resize(shiftedInpU,out_width));
      end generate;

    DOSAT:if(sat=1 or round>=1) 
      generate
        Convert: synBusSatRnd
        generic map(
            inp_width =>tmpInpWidth,
            out_width => out_width,
            infrac => infrac,
            outfrac =>outfrac,
            round => round,
            sat => sat,
            dataType=> saType
          )
        port map(
          inp=>std_logic_vector(shiftedInpU),
          outp=>outp
         );    
      end generate; --DOSAT

  end generate;--if(datatype="unsign")

end behav;

-------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synGain is
generic(
   inp_width : integer := 16;
   out_width: integer := 16;
   coef_width: integer := 2;
   coefVal: std_logic_vector(127 downto 0) := std_logic_vector(to_unsigned(1,128));
   dataType: string := "signed"
);
port (
  inp:  in std_logic_vector(inp_width-1 downto 0);
  outp: out std_logic_vector(out_width-1 downto 0)
);
end synGain;

architecture behav of synGain is
signal inpS: signed(inp_width-1 downto 0);
signal coefS: signed(coef_width-1 downto 0);
signal outS: signed(coef_width+inp_width-1 downto 0);
signal inpU: unsigned(inp_width-1 downto 0);
signal coefU: unsigned(coef_width-1 downto 0);
signal outU: unsigned(coef_width+inp_width-1 downto 0);
begin
  sig: if(datatype="signed") 
    generate
      coefS <= signed(coefVal(coef_width-1 downto 0));
      inpS <= signed(inp);
      outS <= coefS*inpS;      
      outp <= std_logic_vector(outS(out_width-1 downto 0));
    end generate;

  uns: if(datatype="unsign") 
    generate
      coefU <= unsigned(coefVal(coef_width-1 downto 0));
      inpU <= unsigned(inp);
      outU <= coefU*inpU;      
      outp <= std_logic_vector(outU(out_width-1 downto 0));
    end generate;

end behav;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synDelay is
generic(
   bitwidth : integer := 16;
   delay: integer := 1;
   delwidth: integer := 16
);
port (
  clk: in std_logic;
  rst: in std_logic;
  inp:  in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synDelay;

architecture structural of synDelay is
--attribute syn_hier : string;
--attribute syn_hier of structural : architecture is "remove";

type delaylineType is array (0 to delay-1) of std_logic_vector(bitwidth-1 downto 0);
signal delayline : delaylineType := (others => std_logic_vector(to_unsigned(0, bitwidth)));
begin
rg: if((delay < 100) and (delay > 1))
      generate
        dly: process(clk)
        begin
          if(rising_edge(clk)) then
            if(rst='1') then
              for i in delay-1 downto 0 loop
                delayline(i) <= std_logic_vector( to_unsigned(0, bitwidth));
              end loop;
            else
              for i in delay-1 downto 1 loop
                delayline(i) <= delayline(i-1);
              end loop;
              delayline(0) <= inp;
            end if;
          end if;
        end process;
        outp <= delayline(delay-1);
      end generate;

one: if(delay = 1)
      generate
        dly: process(clk)
        begin
          if(rising_edge(clk)) then
            if(rst='1') then
              outp <= std_logic_vector( to_unsigned(0, bitwidth));
            else
              outp <= inp;
            end if;
          end if;
        end process;
      end generate;

bf: if(delay >= 100)
      generate
        bfblock: Block
        signal valid_out: std_logic;
        signal cnt: unsigned(delwidth-1 downto 0) := to_unsigned(0, delwidth);
        signal outbuf: std_logic_vector(bitwidth-1 downto 0) := std_logic_vector(to_unsigned(0, bitwidth));
        begin
          dly: process(clk)
          begin
            if(rising_edge(clk)) then
              if (rst='1') then 
                cnt <=  to_unsigned(0, delwidth);
                valid_out <= '0';
                outbuf <= std_logic_vector(to_unsigned(0, bitwidth));
              else
                if(valid_out='1') then 
                  outbuf <= delayline(to_integer(cnt));
                else
                  outbuf <= std_logic_vector(to_unsigned(0, bitwidth));
                end if;
                delayline(to_integer(cnt)) <= inp;
                if(to_integer(cnt)=delay-2) then
                  cnt <=  to_unsigned(0, delwidth);
                  valid_out <= '1';
                else
                  cnt <= cnt+1;
                end if;
              end if;
            end if;
          end process;
          outp <= outbuf;
        end Block;
      end generate;
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;
use SynDspLib.synLibFunctions.all;

entity synDelayWithEnableGeneric is
generic(
   preferRAMImpl: integer := 1;
   ramThreshold : integer := 68;
   decompRegs : integer := 2;
   decompThresholdMin : integer := 9;
   bitwidth : integer := 16;
   delay: integer := 32
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  inp:  in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synDelayWithEnableGeneric;

architecture structural of synDelayWithEnableGeneric is
attribute syn_hier : string;
attribute syn_hier of structural : architecture is "remove";

constant cntWidth : integer := log_floor(delay);
constant decompThresholdBW : integer := (64 / bitwidth)+2*decompRegs;
constant delayNRLen : integer := zero_bracket(delay-2*decompRegs);

type delayLineFullType is array (0 to delay-1) of std_logic_vector(bitwidth-1 downto 0);
type delayLineClipType is array (0 to delayNRLen-1) of std_logic_vector(bitWidth-1 downto 0);
type decompRegType is array (0 to decompRegs-1) of std_logic_vector(bitWidth-1 downto 0);
signal delayline : delayLineFullType;
signal delayLineClip: delayLineClipType;
signal regsL, regsR : decompRegType;
signal cnt : unsigned(cntWidth-1 downto 0);
signal resetExpired: std_logic;
signal cntDone: std_logic;
begin
  RAMImpl: if (preferRAMImpl = 1)
  generate
    doRAM: if (delay >= ramThreshold)
    generate
      procRAM: process(clk)
      begin
        if (rising_edge(clk)) then
          if (grst='1' or rst='1') then
            resetExpired <= '0';
            cnt <= (others => '0');
            for i in 0 to decompRegs-1 loop
              regsL(i) <= (others => '0');
              regsR(i) <= (others => '0');
            end loop;
          elsif (en='1') then
            if (cnt = delayNRLen -1) then
              cnt <= (others => '0');
              resetExpired <= '1';
            else
              cnt <= cnt + 1;
            end if;
            regsL(0) <= inp;
            for i in 1 to decompRegs-1 loop
              regsL(i) <= regsL(i-1);
              regsR(i) <= regsR(i-1);
            end loop;
            if (resetExpired='1') then
              regsR(0) <= delaylineClip(to_integer(cnt));
            else
              regsR(0) <= (others => '0');
            end if;
            delaylineClip(to_integer(cnt)) <= regsL(decompRegs-1);
          end if;
        end if;  
      end process;
      outp <= regsR(decompRegs-1);
    end generate;
  
    RegDelay: if(delay > 0 and delay < ramThreshold)
    generate
      dly: process(clk)
      begin
        if(rising_edge(clk)) then
          if (grst='1' or rst='1') then 
            for i in delay-1 downto 0 loop
              delayline(i) <= std_logic_vector(to_signed(0, bitwidth));
            end loop;
          elsif (en='1') then 
            for i in delay-1 downto 1 loop
              delayline(i) <= delayline(i-1);
            end loop;
            delayline(0) <= inp;
          end if;
        end if;
      end process;
      outp <= delayline(delay-1);
    end generate;
  end generate; -- yr
  
  srlImp: if (preferRAMImpl /= 1)
  generate
    BigDelay: if(delay >= decompThresholdMin and delay >= decompThresholdBW)
    generate
      noreset: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1' or rst='1') then
            cnt <= (others => '0');
            cntDone <= '0';
            for i in 0 to decompRegs-1 loop
              regsL(i) <= (others => '0');
              regsR(i) <= (others => '0');
            end loop;
          elsif(en='1') then
            if (cnt = delayNRLen-1) then
              cntDone <= '1';
            end if;
            if(cntDone = '0') then
              cnt<=cnt + 1;
            end if;
            regsL(0) <= inp;
            for i in 1 to decompRegs-1 loop
              regsL(i) <= regsL(i-1);
              regsR(i) <= regsR(i-1);
            end loop;
            if(cntDone = '1') then
              regsR(0) <= delaylineClip(delayNRLen-1);
            else
              regsR(0) <= (others=>'0');
            end if;
          end if;  
        end if;
      end process;
      dlyproc: process(clk)
      begin
        if (rising_edge(clk)) then
          if (en='1') then
            for i in delay-2*decompRegs-1 downto 1 loop
              delaylineClip(i) <= delaylineClip(i-1);
            end loop;
            delaylineClip(0) <= regsL(decompRegs-1);
          end if;
        end if;
      end process;
      outp <= regsR(decompRegs-1);
    end generate;    
    
    RegDelay: if(delay > 0 and ((delay < decompThresholdMin) or (delay < decompThresholdBW)))
    generate
      dly: process(clk)
      begin
        if(rising_edge(clk)) then
          if (grst='1' or rst='1') then 
            for i in delay-1 downto 0 loop
              delayline(i) <= std_logic_vector(to_signed(0, bitwidth));
            end loop;
          elsif (en='1') then 
            for i in delay-1 downto 1 loop
              delayline(i) <= delayline(i-1);
            end loop;
            delayline(0) <= inp;
          end if;
        end if;
      end process;
      outp <= delayline(delay-1);
    end generate;
    
  end generate; -- nr


  NoDelay: if(delay = 0)
  generate
    outp <= inp;
  end generate;

end structural;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;
use SynDspLib.synLibFunctions.all;

entity synDelayWithEnable_std_logic_vector is
generic(
   preferRAMImpl: integer := 1;
   bitwidth : integer := 16;
   delay: integer := 32
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  inp:  in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synDelayWithEnable_std_logic_vector;

architecture structural of synDelayWithEnable_std_logic_vector is
attribute syn_hier : string;
attribute syn_hier of structural : architecture is "remove";

signal inpTmp, outTmp : std_logic_vector(bitwidth-1 downto 0);
begin

  inpTmp <= std_logic_vector(inp);
  outp <= outTmp;
  
  singleDelay : synDelayWithEnableGeneric
    generic map( bitwidth => bitwidth, delay => delay, preferRAMImpl => preferRAMImpl)
    port map( clk => clk, en => en, grst => grst, rst => rst, inp => inpTmp, outp => outTmp);

end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;
use SynDspLib.synLibFunctions.all;

entity synDelayWithEnable_unsigned is
generic(
   preferRAMImpl: integer := 1;
   bitwidth : integer := 16;
   delay: integer := 32
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  inp:  in unsigned(bitwidth-1 downto 0);
  outp: out unsigned(bitwidth-1 downto 0)
);
end synDelayWithEnable_unsigned;

architecture structural of synDelayWithEnable_unsigned is
attribute syn_hier : string;
attribute syn_hier of structural : architecture is "remove";

signal inpTmp, outTmp : std_logic_vector(bitwidth-1 downto 0);
begin

  inpTmp <= std_logic_vector(inp);
  outp <= unsigned(outTmp);
  
	singleDelay : synDelayWithEnableGeneric
	  generic map( bitwidth => bitwidth, delay => delay, preferRAMImpl => preferRAMImpl)
	  port map( clk => clk, en => en, grst => grst, rst => rst, inp => inpTmp, outp => outTmp);
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;
use SynDspLib.synLibFunctions.all;

entity synDelayWithEnable_signed is
generic(
   preferRAMImpl: integer := 1;
   bitwidth : integer := 16;
   delay: integer := 32
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  inp:  in signed(bitwidth-1 downto 0);
  outp: out signed(bitwidth-1 downto 0)
);
end synDelayWithEnable_signed;

architecture structural of synDelayWithEnable_signed is
attribute syn_hier : string;
attribute syn_hier of structural : architecture is "remove";

signal inpTmp, outTmp : std_logic_vector(bitwidth-1 downto 0);
begin

  inpTmp <= std_logic_vector(inp);
  outp <= signed(outTmp);
  
	singleDelay : synDelayWithEnableGeneric
	  generic map( bitwidth => bitwidth, delay => delay, preferRAMImpl => preferRAMImpl)
	  port map( clk => clk, en => en, grst => grst, rst => rst, inp => inpTmp, outp => outTmp);
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;
use SynDspLib.synLibFunctions.all;

entity synDelayWithEnable_std_logic is
generic(
   preferRAMImpl: integer := 1;
   delay: integer := 32
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  inp:  in std_logic;
  outp: out std_logic
);
end synDelayWithEnable_std_logic;

architecture structural of synDelayWithEnable_std_logic is
attribute syn_hier : string;
attribute syn_hier of structural : architecture is "remove";

signal inpTmp, outTmp: std_logic_vector(0 downto 0);
begin

  inpTmp(0) <= inp;
  outp <= outTmp(0);
  
	singleDelay : synDelayWithEnableGeneric
	  generic map( bitwidth => 1, delay => delay, preferRAMImpl => preferRAMImpl)
	  port map( clk => clk, en => en, grst => grst, rst => rst, inp => inpTmp, outp => outTmp);
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRobustLatch_signed is
generic(
   ch_no : integer := 1;
   bitwidth : integer := 16
);
port (
  clk: in std_logic;
  gEnable: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  inp:  in signed(bitwidth-1 downto 0);
  outp: out signed(bitwidth-1 downto 0)
);
end synRobustLatch_signed;

architecture structural of synRobustLatch_signed is

type delaylineType is array (0 to ch_no-1) of signed(bitwidth-1 downto 0);
signal inpReg : delaylineType;
begin

  dly: process(clk)
  begin
    if(rising_edge(clk)) then
      if (rst='1') then 
        inpReg <= (others => (others => '0'));
      elsif(gEnable='1') then 
        if (en='1') then 
          inpReg(0) <= inp;
		else
		  inpReg(0) <= inpReg(ch_no-1);
        end if;
        for i in 1 to ch_no-1 loop
          inpReg(i) <= inpReg(i-1);
        end loop;
      end if;
    end if;
  end process;
  outp <= inp when en = '1' else
          inpReg(ch_no-1);
end structural;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRobustLatch_unsigned is
generic(
   ch_no : integer := 1;
   bitwidth : integer := 16
);
port (
  clk: in std_logic;
  gEnable: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  inp:  in unsigned(bitwidth-1 downto 0);
  outp: out unsigned(bitwidth-1 downto 0)
);
end synRobustLatch_unsigned;

architecture structural of synRobustLatch_unsigned is

type delaylineType is array (0 to ch_no-1) of unsigned(bitwidth-1 downto 0);
signal inpReg : delaylineType;
begin

  dly: process(clk)
  begin
    if(rising_edge(clk)) then
      if (rst='1') then 
        inpReg <= (others => (others => '0'));
      elsif(gEnable='1') then 
        if (en='1') then 
          inpReg(0) <= inp;
		else
		  inpReg(0) <= inpReg(ch_no-1);
        end if;
        for i in 1 to ch_no-1 loop
          inpReg(i) <= inpReg(i-1);
        end loop;
      end if;
    end if;
  end process;
  outp <= inp when en = '1' else
          inpReg(ch_no-1);
end structural;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRobustLatch_std_logic is
generic(
   ch_no : integer := 1
);
port (
  clk: in std_logic;
  gEnable: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  inp:  in std_logic;
  outp: out std_logic
  );
end synRobustLatch_std_logic;

architecture structural of synRobustLatch_std_logic is

type delaylineType is array (0 to ch_no-1) of std_logic;
signal inpReg : delaylineType;
begin

  dly: process(clk)
  begin
    if(rising_edge(clk)) then
      if (rst='1') then 
        inpReg <= (others => '0');
      elsif(gEnable='1') then 
        if (en='1') then 
          inpReg(0) <= inp;
		else
		  inpReg(0) <= inpReg(ch_no-1);
        end if;
        for i in 1 to ch_no-1 loop
          inpReg(i) <= inpReg(i-1);
        end loop;
      end if;
    end if;
  end process;
  outp <= inp when en = '1' else
          inpReg(ch_no-1);
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRobustLatch_std_logic_vector is
generic(
   ch_no : integer := 1;
   bitwidth : integer := 16
);
port (
  clk: in std_logic;
  gEnable: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  inp:  in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synRobustLatch_std_logic_vector;

architecture structural of synRobustLatch_std_logic_vector is

type delaylineType is array (0 to ch_no-1) of std_logic_vector(bitwidth-1 downto 0);
signal inpReg : delaylineType;
begin

  dly: process(clk)
  begin
    if(rising_edge(clk)) then
      if (rst='1') then 
        inpReg <= (others => (others => '0'));
      elsif(gEnable='1') then 
        if (en='1') then 
          inpReg(0) <= inp;
		else 
		  inpReg(0) <= inpReg(ch_no-1);
        end if;
        for i in 1 to ch_no-1 loop
          inpReg(i) <= inpReg(i-1);
        end loop;
      end if;
    end if;
  end process;
  outp <= inp when en = '1' else
          inpReg(ch_no-1);
end structural;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synDataTypes.all;

entity synMux is
generic(
  inp_width : integer := 2;
  inp_size :  integer := 3;
  sel_bits :  integer := 2
);
port (
  sel:  in unsigned(sel_bits-1 downto 0);
  inp:  in matrix(0 to inp_size-1, inp_width-1 downto 0);
  outp: out std_logic_vector(inp_width-1 downto 0)
);
end synMux;

architecture behav of synMux is

begin
  floop: for i in inp_width-1 downto 0 generate
     outp(i) <= inp(to_integer(sel), i);
  end generate;
end;
------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synCounter is
generic(
  en_exists: std_logic := '1';
  rst_exists: std_logic := '1';
  ld_exists: std_logic := '0';
  rdy_exists: std_logic := '0';
  ctype: integer := 2;
  ival: integer := 0;
  tval: integer := 127;
  bitwidth : integer := 16;
  isSigned: std_logic := '0'
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  up: in std_logic;
  ld: in std_logic;
  din: in std_logic_vector(bitwidth-1 downto 0);
  cnt: out std_logic_vector(bitwidth-1 downto 0);
  rdy: out std_logic
);
end synCounter;

architecture behav of synCounter is
signal cntU : unsigned(bitwidth-1 downto 0);
signal cntS : signed(bitwidth-1 downto 0);
begin
  usig: if (isSigned = '0')
    generate
      countU: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1' or (rst='1' and rst_exists='1')) then
            cntU <= to_unsigned(ival, bitwidth); 
          else        
            if(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntU <= unsigned(din);
              else
                    if(cntU=to_unsigned(tval, bitwidth)) then
                      cntU <= to_unsigned(ival, bitwidth);
                    else
                  if(ctype=1) then          
                    if(up='1') then
                      cntU <= cntU + 1;
                  else
                      cntU <= cntU - 1;
                    end if;
                  elsif(ctype=2) then
                    cntU <= cntU + 1;
                  else
                    cntU <= cntU - 1;
                  end if;
                end if;
              end if;
            end if;
          end if;
        end if;
      end process;
      cnt <= std_logic_vector(cntU);
      rdy <= '1' when (cntU=to_unsigned(tval, bitwidth) and rdy_exists='1') else '0';

    end generate;

  sig: if (isSigned = '1')
    generate
      countS: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1' or (rst='1' and rst_exists='1')) then
            cntS <= to_signed(ival, bitwidth); 
          else   
            if(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntS <= signed(din);
              else
                    if(cntS=to_signed(tval, bitwidth)) then
                      cntS <= to_signed(ival, bitwidth);
                    else
                  if(ctype=1) then          
                    if(up='1') then
                      cntS <= cntS + 1;
                  else
                      cntS <= cntS - 1;
                    end if;
                  elsif(ctype=2) then
                    cntS <= cntS + 1;
                  else
                    cntS <= cntS - 1;
                  end if;
                end if;
              end if;
            end if;
          end if;  
        end if;
      end process;
      cnt <= std_logic_vector(cntS);
	  rdy <= '1' when (cntS=to_signed(tval, bitwidth) and rdy_exists='1') else '0';

    end generate;

end behav;


------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synCounterSync is
generic(
  tval: integer := 127;
  sample_offset : integer := 0;
  bitwidth: integer := 16
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rdy: out std_logic
);
end synCounterSync;

architecture behav of synCounterSync is
signal cntU : unsigned(bitwidth-1 downto 0);
signal rdyR : std_logic;
begin
      countU: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            cntU <= to_unsigned(0, bitwidth);
			if ( sample_offset=0 ) then
			  rdyR <= '1';
 			else
			  rdyR <= '0';
			end if;
          else        
            if(en='1' ) then
              if(cntU=to_unsigned(tval, bitwidth)) then
                cntU <= to_unsigned(0, bitwidth);
              else
                cntU <= cntU + 1;
              end if;
              if(cntU=to_unsigned( (sample_offset+tval) mod (tval+1), bitwidth)) then
                rdyR <= '1';
              else
                rdyR <= '0';
              end if;
            end if;
          end if;
        end if;
      end process;
      rdy <= rdyR;

end behav;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synCounterFR is -- Free running version
generic(
  en_exists: std_logic := '1';
  rst_exists: std_logic := '1';
  ld_exists: std_logic := '0';
  ctype: integer := 2;
  ival: integer := 0;
  tval: integer := 127;
  bitwidth : integer := 16;
  isSigned: std_logic := '0'
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  up: in std_logic;
  ld: in std_logic;
  din: in std_logic_vector(bitwidth-1 downto 0);
  cnt: out std_logic_vector(bitwidth-1 downto 0)
);
end synCounterFR;

architecture behav of synCounterFR is
signal cntU : unsigned(bitwidth-1 downto 0);
signal cntS : signed(bitwidth-1 downto 0);
begin
  usig: if (isSigned = '0')
    generate
      countU: process(clk)
      begin
        if(rising_edge(clk)) then
		  if (grst='1' or (rst='1' and rst_exists='1')) then
            cntU <= to_unsigned(ival, bitwidth); 
          else
            if(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntU <= unsigned(din);
              else
                if(ctype=1) then          
                  if(up='1') then
                    cntU <= cntU + 1;
                  else
                    cntU <= cntU - 1;
                  end if;
                elsif(ctype=2) then
                  cntU <= cntU + 1;
                else
                  cntU <= cntU - 1;
                end if;
              end if;
            end if;
          end if;  
        end if;
      end process;
      cnt <= std_logic_vector(cntU);
    end generate;

  sig: if (isSigned = '1')
    generate
      countS: process(clk)
      begin
        if(rising_edge(clk)) then
		  if (grst='1' or (rst='1' and rst_exists='1')) then
            cntS <= to_signed(ival, bitwidth); 
          else
            if(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntS <= signed(din);
              else
                if(ctype=1) then          
                  if(up='1') then
                    cntS <= cntS + 1;
                  else
                    cntS <= cntS - 1;
                  end if;
                elsif(ctype=2) then
                  cntS <= cntS + 1;
                else
                  cntS <= cntS - 1;
                end if;
              end if;
            end if;
          end if;  
        end if;
      end process;
      cnt <= std_logic_vector(cntS);
    end generate;

end behav;

------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRegister is
generic(
   bitwidth : integer := 16
);
port (
  clk: in std_logic;
  D: in std_logic_vector(bitwidth-1 downto 0);
  en: in std_logic;
  rst: in std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synRegister;

architecture behav of synRegister is
signal regout : std_logic_vector(bitwidth-1 downto 0) 
               := std_logic_vector(to_unsigned(0, bitwidth));
begin
  regproc: process(clk)
  begin
    if(rising_edge(clk)) then
      if(rst='1') then
        regout <= std_logic_vector(to_unsigned(0, bitwidth)); 
      elsif(en='1') then
        regout <= D;
      end if;
    end if;
  end process;
  outp <= regout;
end behav;

------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synAbs is
generic(
   bitwidth : integer := 16
);
port (
  inp: in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synAbs;

architecture behav of synAbs is
signal ins: signed(bitwidth-1 downto 0);
begin
  ins <= signed(inp);

  outp <= std_logic_vector(-ins) when ins<0 else
          std_logic_vector(ins);

end behav;

------------------------------------------------------
--Accumulator block is modified to read output from the adder output
--instead of register output as it was in pre-modified version
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synAccumulator is
generic(
   bitwidth : integer := 16;
   datatype: string := "signed";
   opr: string := "+="
);
port (
  clk: in std_logic;
  inp: in std_logic_vector(bitwidth-1 downto 0);
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synAccumulator;

architecture behav of synAccumulator is
signal accU : unsigned(bitwidth-1 downto 0) := (others => '0');
signal accS : signed(bitwidth-1 downto 0) := (others => '0');
signal addOutS : signed(bitwidth-1 downto 0) := (others => '0');
signal addOutU : unsigned(bitwidth-1 downto 0) := (others => '0');
begin
  sig: if (datatype = "signed")
    generate
      accprocsig: process(clk)
      begin
        if(rising_edge(clk)) then
          if((grst='1') or (rst='1')) then
            accS <= to_signed(0, bitwidth);
          else
            if(en='1') then
              accS <= addOutS;
            end if;
          end if;  
        end if;
      end process;
     
      addOutS <= accS + signed(inp) when opr ="+=" else
                 accS - signed(inp);
      outp <= std_logic_vector(accS);
    
    end generate;

  uns: if (datatype = "unsign")
    generate
      accprocuns: process(clk)
      begin
        if(rising_edge(clk)) then
          if((grst='1') or (rst='1'))then
            accU <= to_unsigned(0, bitwidth);
          else  
            if(en='1') then
              accU <= addOutU;
            end if;
          end if;  
        end if;
      end process;
    
      addOutU <= accU + unsigned(inp) when opr ="+=" else
                 accU - unsigned(inp);
    
      outp <= std_logic_vector(accU);

   end generate;
  
end behav;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synAccumulatorOvf is
generic(
   bitwidth : integer := 16;
   datatype: string := "signed";
   opr: string := "+="
);
port (
  clk: in std_logic;
  inp: in std_logic_vector(bitwidth-1 downto 0);
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  ovf: out std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synAccumulatorOvf;

architecture behav of synAccumulatorOvf is
signal accU : unsigned(bitwidth-1 downto 0) := (others => '0');
signal accS : signed(bitwidth-1 downto 0) := (others => '0');
signal addOutS : signed(bitwidth-1 downto 0) := (others => '0');
signal addOutU : unsigned(bitwidth downto 0) := (others => '0');
signal ovfReg : std_logic;
signal ovfLine: std_logic;

begin
  sig: if (datatype = "signed")
    generate
      accprocsig: process(clk)
      begin
        if(rising_edge(clk)) then
          if((grst='1') or (rst='1')) then
            accS <= to_signed(0, bitwidth);
            ovfReg <= '0';
          else
            if(en='1') then
              accS <= syn_resize(addOutS, bitwidth);
              ovfReg <= ovfLine;
            end if;
          end if;  
        end if;
      end process;
     
      addOutS <= accS + signed(inp) when opr ="+=" else
                 accS - signed(inp);
      outp <= std_logic_vector(accS);
      ovfLine <= '1' when ((opr = "+=" and accS(bitwidth-1) = inp(bitwidth-1)) or 
                         (opr = "-=" and accS(bitwidth-1) /= inp(bitwidth-1))) and
                (addOutS(bitwidth-1) /= accS(bitwidth-1)) else '0';
      ovf <= ovfReg;
    
    end generate;

  uns: if (datatype = "unsign")
    generate
      accprocuns: process(clk)
      begin
        if(rising_edge(clk)) then
          if((grst='1') or (rst='1'))then
            accU <= to_unsigned(0, bitwidth);
            ovfReg <= '0';
          else  
            if(en='1') then
              accU <= syn_resize(addOutU, bitwidth);
              ovfReg <= ovfLine;
            end if;
          end if;  
        end if;
      end process;
    
      addOutU <= syn_resize(accU,bitwidth+1) + syn_resize(unsigned(inp), bitwidth+1) when opr ="+=" else
                 syn_resize(accU,bitwidth+1) - syn_resize(unsigned(inp), bitwidth+1);
    
      outp <= std_logic_vector(accU);
      ovfLine <= addOutU(bitwidth);
      ovf <= ovfReg;

   end generate;
  
end behav;


------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synBinLogic is
generic(
   bitwidth : integer := 16;
   opr: string := "ANDD"
);
port (
  inpA: in std_logic_vector(bitwidth-1 downto 0);
  inpB: in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synBinLogic;

architecture behav of synBinLogic is
begin
  outp <= inpA and inpB when opr="ANDD" else
          inpA or inpB when opr="ORRR" else
          inpA xor inpB when opr="XORR" else
          inpA nand inpB when opr="NAND" else
          inpA nor inpB when opr="NORR" else
          not(inpA xor inpB);
end behav;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synComparator is
generic(
   bitwidth : integer := 16;
   datatype: string := "signed";
   opr: string := "equ"
);
port (
  inpA: in std_logic_vector(bitwidth-1 downto 0);
  inpB: in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(0 downto 0)
);
end synComparator;

architecture behav of synComparator is
signal AS : signed(bitwidth-1 downto 0);
signal AU : unsigned(bitwidth-1 downto 0);
signal BS : signed(bitwidth-1 downto 0);
signal BU : unsigned(bitwidth-1 downto 0);

begin
  sig: if (datatype = "signed")
    generate
      AS <= signed(inpA);
      BS <= signed(inpB);
 
      eq: if(opr="equ") generate
        outp <= "1" when AS = BS else "0";
      end generate;
      
      neq: if(opr="neq") generate
        outp <= "1" when AS /= BS else "0";
      end generate;

      les: if(opr="les") generate
        outp <= "1" when AS < BS else "0";
      end generate;

      leq: if(opr="leq") generate
        outp <= "1" when AS <= BS else "0";
      end generate;
               
      gre: if(opr="gtr") generate
        outp <= "1" when AS > BS else "0";
      end generate;

      geq: if(opr="geq") generate
        outp <= "1" when AS >= BS else "0";
      end generate;
    end generate;

  uns: if (datatype = "unsign")
    generate
      AU <= unsigned(inpA);
      BU <= unsigned(inpB);
 
      eq: if(opr="equ") generate
        outp <= "1" when AU = BU else "0";
      end generate;
      
      neq: if(opr="neq") generate
        outp <= "1" when AU /= BU else "0";
      end generate;

      les: if(opr="les") generate
        outp <= "1" when AU < BU else "0";
      end generate;

      leq: if(opr="leq") generate
        outp <= "1" when AU <= BU else "0";
      end generate;
               
      gre: if(opr="gtr") generate
        outp <= "1" when AU > BU else "0";
      end generate;

      geq: if(opr="geq") generate
        outp <= "1" when AU >= BU else "0";
      end generate;
    end generate;

end behav;

------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synInverter is
generic(
   bitwidth : integer := 16
);
port (
  inp: in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synInverter;

architecture behav of synInverter is
begin
  outp <= not inp;
end behav;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synNegate is
generic(
   bitwidth : integer := 16
);
port (
  inp: in std_logic_vector(bitwidth-1 downto 0);
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synNegate;

architecture behav of synNegate is
begin
  outp <= std_logic_vector(-signed(inp));
end behav;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synShifter is
generic(
   inpBitW : integer := 16;
   outBitW : integer := 16;
   shfBitW : integer := 16;
   datatype: string := "signed";
   opr: string := "<<"
);
port (
  inp: in std_logic_vector(inpBitW-1 downto 0);
  shf: in std_logic_vector(shfBitW-1 downto 0);
  outp: out std_logic_vector(outBitW-1 downto 0)
);
end synShifter;

architecture behav of synShifter is
begin
  sig: if (datatype = "signed")
    generate
      lft: if(opr="<<") generate
        outp <= std_logic_vector(Shift_Left(Resize(signed(inp),outBitW), to_integer(unsigned(shf))));
      end generate;
      
      rgt: if(opr=">>") generate
        outp <= std_logic_vector(Shift_Right(Resize(signed(inp),outBitW), to_integer(unsigned(shf))));
      end generate;
    end generate;

  uns: if (datatype = "unsign")
    generate
      lft: if(opr="<<") generate
        outp <= std_logic_vector(Shift_Left(Resize(unsigned(inp),outBitW), to_integer(unsigned(shf))));
      end generate;
      
      rgt: if(opr=">>") generate
        outp <= std_logic_vector(Shift_Right(Resize(unsigned(inp),outBitW), to_integer(unsigned(shf))));
      end generate;
    end generate;
end behav;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synShifterR is
generic(
   inpBitW : integer := 16;
   outBitW : integer := 16;
   shfBitW : integer := 16;
   datatype: string := "signed";
   opr: string := "<<"
);
port (
  inp: in std_logic_vector(inpBitW-1 downto 0);
  shf: in std_logic_vector(shfBitW-1 downto 0);
  outp: out std_logic_vector(outBitW-1 downto 0)
);
end synShifterR;

architecture behav of synShifterR is
signal signedshift : signed( shfBitW downto 0);
begin
  signedshift <= Resize(signed(shf),shfBitW+1);

  sig: if (datatype = "signed")
    generate
      lft: if(opr="<<") generate
        outp <= std_logic_vector(Shift_Left(Resize(signed(inp),outBitW), to_integer(signed(signedshift)))) when signedshift(signedshift'length-1) = '0' else
                std_logic_vector(Shift_Right(Resize(signed(inp),outBitW), to_integer(-signed(signedshift))));
      end generate;
      
      rgt: if(opr=">>") generate
        outp <= std_logic_vector(Shift_Right(Resize(signed(inp),outBitW), to_integer(signed(signedshift)))) when signedshift(signedshift'length-1) = '0' else
                std_logic_vector(Shift_Left(Resize(signed(inp),outBitW), to_integer(-signed(signedshift))));
      end generate;
    end generate;

  uns: if (datatype = "unsign")
    generate
      lft: if(opr="<<") generate
        outp <= to_stdlogicvector(to_bitvector(std_logic_vector(Resize(unsigned(inp),outBitW))) sll to_integer(signed(shf)));
      end generate;
      
      rgt: if(opr=">>") generate
        outp <= to_stdlogicvector(to_bitvector(std_logic_vector(Resize(unsigned(inp),outBitW))) srl to_integer(signed(shf)));
      end generate;
    end generate;
end behav;
------------------------------------------------------
--library ieee;
--use ieee.std_logic_1164.all;
--use ieee.numeric_std.all;

--entity synMult is
--generic(
--   inpABitW : integer := 16;
--   inpBBitW : integer := 16
--);
--port (
--  inpA: in std_logic_vector(inpABitW-1 downto 0);
--  inpB: in std_logic_vector(inpBBitW-1 downto 0);
--  outp: out std_logic_vector(inpABitW+inpBBitW-2 downto 0)
--);
--end synMult;

--architecture behav of synMult is
--signal mlt : signed(inpABitW+inpBBitW-1 downto 0);
--begin
--  mlt <= signed(inpA)*signed(inpB);
--  outp <= std_logic_vector(mlt(inpABitW+inpBBitW-2 downto 0));
--end behav;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synFIFO is
generic(
   bitwidth : integer := 16;
   depth    : integer := 16;
   cntwidth : integer := 5;
   adrWidth : integer := 4
);
port (
  clk: in std_logic;
  din: in std_logic_vector(bitwidth-1 downto 0);
  we: in std_logic;
  re: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  dout: out std_logic_vector(bitwidth-1 downto 0);
  full: out std_logic;
  empty: out std_logic;
  itemcnt: out std_logic_vector(cntwidth-1 downto 0)
);
end synFIFO;

architecture behav of synFIFO is
type fifoMemType is array (0 to depth-1) of std_logic_vector(bitwidth-1 downto 0);
signal fifoMem : fifoMemType := (others => std_logic_vector(to_unsigned(0, bitwidth)));
signal full_reg : std_logic := '0';
signal not_empty_reg : std_logic := '0';
signal cnt: unsigned(cntwidth-1 downto 0) := to_unsigned(0, cntwidth);
signal readAddr: unsigned(adrWidth-1 downto 0) := to_unsigned(0, adrWidth);
signal writeAddr: unsigned(adrWidth-1 downto 0) := to_unsigned(0, adrWidth);
signal dout_reg: std_logic_vector(bitwidth-1 downto 0) := std_logic_vector(to_unsigned(0, bitwidth));
signal willWrite: std_logic;
signal willRead: std_logic;
signal incCnt: std_logic;
signal decCnt: std_logic;
begin
  dout <= dout_reg;
  full <= full_reg;
  empty <= not not_empty_reg;
  itemcnt <= std_logic_vector(cnt);

  willRead <= '1' when not_empty_reg='1' and re ='1'else
              '0' ;
  willWrite <= '1' when (full_reg='0' or re='1') and we ='1' else
               '0';
  
  incCnt <= '1' when willWrite='1' and willRead = '0' else
            '0';
  decCnt <= '1' when willRead='1' and willWrite = '0' else
            '0';
  
  fifiProc: process(clk)
  begin
    if(rising_edge(clk)) then
      if(grst='1' or rst='1') then
        dout_reg <= std_logic_vector(to_unsigned(0, bitwidth));
        full_reg <= '0';
        not_empty_reg <= '0';
        readAddr <= to_unsigned(0, adrWidth);
        writeAddr <= to_unsigned(0, adrWidth);
        cnt <= to_unsigned(0, cntwidth);    
      else       
        if(willRead='1') then
          dout_reg <= fifoMem(to_integer(readAddr));
          if(to_integer(readAddr) = depth-1) then
            readAddr <= to_unsigned(0, adrWidth);
          else
            readAddr <= readAddr + 1;
          end if;
        end if;

        if(willWrite='1') then
          fifoMem(to_integer(writeAddr)) <= din;
          if(to_integer(writeAddr) = depth-1) then
            writeAddr <= to_unsigned(0, adrWidth);
          else
            writeAddr <= writeAddr + 1;
          end if;
        end if;

        if((to_integer(cnt) = depth and decCnt='0') or
          (to_integer(cnt) = depth-1 and incCnt='1')) then
          full_reg <= '1';
        else
          full_reg <= '0';
        end if;

        if((to_integer(cnt) = 0 and incCnt='0') or
          (to_integer(cnt) = 1 and decCnt='1')) then
          not_empty_reg <= '0';
        else
          not_empty_reg <= '1';
        end if;

        if(incCnt='1') then
          cnt <= cnt + 1;
        elsif (decCnt='1') then
          cnt <= cnt - 1;
        end if;
      end if;      
    end if;
  end process;
end behav;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synAsyncFIFO is
generic(
   bitwidth : integer := 16;
   depth    : integer := 32;
   cntwidth : integer := 6;	 -- will be adrwidth + 1 
   adrwidth : integer := 5
);
port (
  wclk: in std_logic;
  wge : in std_logic;  -- global enable write
  rclk: in std_logic;
  rge : in std_logic;  -- global enable read
  din: in std_logic_vector(bitwidth-1 downto 0);
  we: in std_logic;
  re: in std_logic;
  grst: in std_logic;
  dout: out std_logic_vector(bitwidth-1 downto 0);
  full: out std_logic;
  empty: out std_logic
);
end synAsyncFIFO;

architecture rtl of synAsyncFIFO is
type fifoMemType is array (0 to depth-1) of std_logic_vector(bitwidth-1 downto 0);
signal fifoMem : fifoMemType := (others => (others => '0'));
signal dout_reg: std_logic_vector(bitwidth-1 downto 0) := std_logic_vector(to_unsigned(0, bitwidth));

signal empty_int : std_logic;
signal full_int : std_logic;
signal nextreadaddress : std_logic_vector(adrwidth-1 downto 0);
signal nextwriteaddress : std_logic_vector(adrwidth-1 downto 0);
signal willWrite: std_logic;
signal willRead: std_logic;

signal bin_cnt_rd : unsigned(cntwidth-1 downto 0); 
signal bin_cnt_wr : unsigned(cntwidth-1 downto 0); 
signal gray_cnt_rd : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_wr : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_rd_buf : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_wr_buf : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_rd_sync1 : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_wr_sync1 : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_rd_sync2 : std_logic_vector(cntwidth-1 downto 0); 
signal gray_cnt_wr_sync2 : std_logic_vector(cntwidth-1 downto 0); 

begin
  
  willWrite <= we  and wge and not(full_int);
  willRead  <= re  and rge and not(empty_int);
  dout <= dout_reg;

  read_out: process (rclk)
  begin
    if rising_edge(rclk) then
      if (grst = '1') then
        dout_reg <= (others => '0');
  	  elsif (willRead = '1') then
	      dout_reg <= fifoMem(to_integer(unsigned(nextreadaddress)));
	  end if;
    end if;  
  end process read_out;

  write_in: process (wclk)
  begin
    if rising_edge(wclk) then
  	  if (willWrite = '1') then
	    fifoMem(to_integer(unsigned(nextwriteaddress))) <= din;
	  end if;
    end if;
  end process write_in;

  GrayCounter_rd : process (rclk)
  begin
    if rising_edge(rclk) then
	  if (grst = '1') then
	    bin_cnt_rd  <= to_unsigned(1,cntwidth);
		gray_cnt_rd    <= (others => '0');
	  elsif (willRead = '1') then 
		bin_cnt_rd  <= bin_cnt_rd + 1;
		gray_cnt_rd    <= std_logic_vector(bin_cnt_rd) xor ('0' & std_logic_vector(bin_cnt_rd(cntwidth-1 downto 1)));
	  end if;
    end if;
  end process  GrayCounter_rd;
  gray_cnt_rd_buf <= gray_cnt_rd;
  GrayCounter_wr : process (wclk)
  begin
    if rising_edge(wclk) then
	  if (grst = '1') then
	    bin_cnt_wr  <= to_unsigned(1,cntwidth);
		gray_cnt_wr    <= (others => '0');
	  elsif (willWrite = '1') then 
		bin_cnt_wr  <= bin_cnt_wr + 1;
		gray_cnt_wr    <= std_logic_vector(bin_cnt_wr) xor ('0' & std_logic_vector(bin_cnt_wr(cntwidth-1 downto 1)));
	  end if;
    end if;
  end process  GrayCounter_wr;
  gray_cnt_wr_buf <= gray_cnt_wr;

  nextreadaddress  <= 	std_logic_vector(bin_cnt_rd(adrwidth-1 downto 0));
  nextwriteaddress <= 	std_logic_vector(bin_cnt_wr(adrwidth-1 downto 0));
  empty <= empty_int;
  full <= full_int;

  empty_int <= '1' when gray_cnt_wr_sync2 = gray_cnt_rd else '0';
  full_signal_gt : if (adrwidth > 1 ) generate
    full_int  <= '1' when gray_cnt_rd_sync2(adrwidth-2 downto 0) = gray_cnt_wr(adrwidth-2 downto 0) and
  					gray_cnt_rd_sync2(adrwidth downto adrwidth-1) = not(gray_cnt_wr(adrwidth downto adrwidth-1)) 
			      else '0';
  end generate;
  full_signal_eq : if (adrwidth = 1 ) generate
    full_int  <= '1' when gray_cnt_rd_sync2(adrwidth downto adrwidth-1) = not(gray_cnt_wr(adrwidth downto adrwidth-1)) 
			      else '0';
  end generate;

  sync_full : process(wclk)
  begin
	if rising_edge(wclk)	then
  	  if (grst = '1') then
	  	 gray_cnt_rd_sync1 <= (others => '0');
		 gray_cnt_rd_sync2 <= (others => '0');
	  elsif (wge = '1') then
	  	 gray_cnt_rd_sync1 <= gray_cnt_rd_buf;
		 gray_cnt_rd_sync2 <= gray_cnt_rd_sync1;
	  end if;
	end if;
  end process;

  sync_empty : process(grst,rclk)
  begin
	if rising_edge(rclk)	then
  	  if (grst = '1') then
	  	 gray_cnt_wr_sync1 <= (others => '0');
		 gray_cnt_wr_sync2 <= (others => '0');
      elsif (rge = '1') then
	  	 gray_cnt_wr_sync1 <= gray_cnt_wr_buf;
		 gray_cnt_wr_sync2 <= gray_cnt_wr_sync1;
	 end if;
    end if;	 
  end process;

end rtl;
------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synSRL is
generic(
   bitwidth : integer := 16;
   depth : integer := 16;
   swidth : integer := 4
);
port (
  clk : in std_logic;
  rst : in std_logic;
  en : in std_logic;
  Inp :   in std_logic_vector(bitwidth-1 downto 0);
  Outp :   out std_logic_vector(bitwidth-1 downto 0);
  cnt :   in unsigned(swidth-1 downto 0)
);
end synSRL;

architecture structural of synSRL is

type delaylineType is array (0 to depth-1) of std_logic_vector(bitwidth-1 downto 0);
signal delayline : delaylineType := (others => std_logic_vector(to_unsigned(0, bitwidth)));

begin

  Outp <= delayline(to_integer(cnt));

  dly: process(clk)
  begin
    if(rising_edge(clk)) then
      if(rst='1') then
        delayline <= (others => std_logic_vector(to_unsigned(0, bitwidth)));
      elsif(en='1') then
        for i in depth-1 downto 1 loop
          delayline(i) <= delayline(i-1);
        end loop;
        delayline(0) <= Inp;
      end if;
    end if;
  end process;
end structural;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synCSAUnit is
generic (bitWidth : integer := 64);
port (
	a		: in std_logic_vector(bitWidth-1 downto 0);
	b		: in std_logic_vector(bitWidth-1 downto 0);
	c		: in std_logic_vector(bitWidth-1 downto 0);
  	slow	: out std_logic_vector(bitWidth-1 downto 0);
	shigh	: out std_logic_vector(bitWidth-1 downto 0)
);
end synCSAUnit;

architecture behav of synCSAUnit is
begin
	slgen: for I in 0 to bitWidth-1 generate
      	slow(I)   <= a(I) xor b(I) xor c(I);
	end generate;
	shgen: for I in 0 to bitWidth-2 generate
	  	shigh(I+1) <= (a(I) and b(I)) or (a(I)and c(I)) or (b(I) and c(I));
	end generate;
	shigh(0) <= '0';
end behav;

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synPipelinedAdd is
generic (bitWidth : integer := 64);
port (
 	clk		: in std_logic;
  	gReset	: in std_logic;
  	gEnable	: in std_logic;
	a		: in std_logic_vector(bitWidth-1 downto 0);
	b		: in std_logic_vector(bitWidth-1 downto 0);
  	Sum		: out std_logic_vector(bitWidth-1 downto 0)
);
end synPipelinedAdd;

architecture behav of synPipelinedAdd is
constant hbw : integer := bitWidth/2;
constant lbw : integer := bitWidth - hbw;

signal suml, sumlPre : std_logic_vector(lbw downto 0);
signal ah,bh: std_logic_vector(hbw-1 downto 0);

begin
    Sum(bitWidth-1 downto lbw) <= std_logic_vector(resize(signed(ah) + signed (bh) + 1,hbw))when (suml(lbw)='1') else
	                        std_logic_vector(signed(ah) + signed (bh));
    Sum(lbw-1 downto 0) <= suml(lbw-1 downto 0);
    sumlPre <= std_logic_vector(resize(unsigned(a(lbw-1 downto 0)),lbw+1) + resize(unsigned(b(lbw-1 downto 0)),lbw+1));

    adelay : synDelayWithEnable_std_logic_vector
	    generic map( bitwidth => hbw, delay => 1)
  	    port map( clk => clk, en => gEnable, grst => gReset, rst => '0', inp => a(bitWidth-1 downto lbw), outp => ah);
    bdelay : synDelayWithEnable_std_logic_vector
	    generic map( bitwidth => hbw, delay => 1)
  	    port map( clk => clk, en => gEnable, grst => gReset, rst => '0', inp => b(bitWidth-1 downto lbw), outp => bh);
    sdelay : synDelayWithEnable_std_logic_vector
	    generic map( bitwidth => lbw+1, delay => 1)
  	    port map( clk => clk, en => gEnable, grst => gReset, rst => '0', inp => sumlPre, outp => suml);
end behav;

------------------------------------------------------
------   Multi-channel implementations     -----------
------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synRegisterMC is
generic(
   bitwidth : integer := 16;
   ch_no    : integer := 64
);
port (
  clk: in std_logic;
  D: in std_logic_vector(bitwidth-1 downto 0);
  en: in std_logic;
  rst: in std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synRegisterMC;

architecture behav of synRegisterMC is
type regType is array (0 to ch_no-1) of std_logic_vector(bitwidth-1 downto 0);
signal regs : regType := (others => std_logic_vector(to_unsigned(0, bitwidth)));
begin
  regproc: process(clk)
  begin
    if(rising_edge(clk)) then
      if(rst='1') then
        regs(0) <= std_logic_vector(to_unsigned(0, bitwidth)); 
      elsif(en='1') then
        regs(0) <= D;
    else
      regs(0) <= regs(ch_no-1);
      end if;
      
    for i in ch_no-1 downto 1 loop
        regs(i) <= regs(i-1);
      end loop;

    end if;
  end process;
  outp <= regs(ch_no-1);
end behav;
--------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synCounterMC is -- Multi-channel version
generic(
  ch_no : integer := 4;
  en_exists: std_logic := '1';
  rst_exists: std_logic := '1';
  ld_exists: std_logic := '0';
  rdy_exists: std_logic := '0';
  ctype: integer := 2;
  ival: integer := 0;
  tval: integer := 127;
  bitwidth : integer := 16;
  isSigned: std_logic := '0'
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  up: in std_logic;
  ld: in std_logic;
  din: in std_logic_vector(bitwidth-1 downto 0);
  cnt: out std_logic_vector(bitwidth-1 downto 0);
  rdy: out std_logic
);
end synCounterMC;

architecture behav of synCounterMC is

type cntTypeU is array (0 to ch_no-1) of unsigned(bitwidth-1 downto 0);
signal cntsU : cntTypeU;
type cntTypeS is array (0 to ch_no-1) of signed(bitwidth-1 downto 0);
signal cntsS : cntTypeS;

begin
  usig: if (isSigned = '0')
    generate
      countU: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            cntsU <= (others => to_unsigned(ival, bitwidth));        
          else
            if(rst='1' and rst_exists='1') then
              cntsU(0) <= to_unsigned(ival, bitwidth); 
            elsif(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntsU(0) <= unsigned(din);
              else
                if(cntsU(ch_no-1)=to_unsigned(tval, bitwidth)) then
                  cntsU(0) <= to_unsigned(ival, bitwidth);
                else
                if(ctype=1) then
                  if(up='1') then
                      cntsU(0) <= cntsU(ch_no-1) + 1;
                  else
                    cntsU(0) <= cntsU(ch_no-1) - 1;
                  end if;
                elsif(ctype=2) then
                    cntsU(0) <= cntsU(ch_no-1) + 1;
                else
                  cntsU(0) <= cntsU(ch_no-1) - 1;
                  end if;
                end if;
              end if;
            else
              cntsU(0) <= cntsU(ch_no-1);
            end if;
                    
            for i in ch_no-1 downto 1 loop
              cntsU(i) <= cntsU(i-1);
            end loop;
          end if;
        end if;
      end process;
      cnt <= std_logic_vector(cntsU(ch_no-1));
	  rdy <= '1' when (cntsU(ch_no-1)=to_unsigned(tval, bitwidth) and rdy_exists='1') else '0';

    end generate;

  sig: if (isSigned = '1')
    generate
      countS: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            cntsS <= (others => to_signed(ival, bitwidth));        
          else
            if(rst='1' and rst_exists='1') then
              cntsS(0) <= to_signed(ival, bitwidth); 
            elsif(en='1' or en_exists='0') then
              if(ld='1' and ld_exists='1') then
                cntsS(0) <= signed(din);
              else
                if(cntsS(ch_no-1)=to_signed(tval, bitwidth)) then
                  cntsS(0) <= to_signed(ival, bitwidth);
                else
                if(ctype=1) then
                  if(up='1') then
                      cntsS(0) <= cntsS(ch_no-1) + 1;
                  else
                    cntsS(0) <= cntsS(ch_no-1) - 1;
                  end if;
                elsif(ctype=2) then
                    cntsS(0) <= cntsS(ch_no-1) + 1;
                else
                  cntsS(0) <= cntsS(ch_no-1) - 1;
                  end if;
                end if;
              end if;
            else
              cntsS(0) <= cntsS(ch_no-1);
            end if;

            for i in ch_no-1 downto 1 loop
              cntsS(i) <= cntsS(i-1);
            end loop;
          end if;
        end if;
      end process;
      cnt <= std_logic_vector(cntsS(ch_no-1));
	  rdy <= '1' when (cntsS(ch_no-1)=to_signed(tval, bitwidth) and rdy_exists='1') else '0';
    end generate;

end behav;

------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synCounterFRMC is -- Free-running multi-channel version
generic(
   ch_no : integer := 4;
   en_exists: std_logic := '1';
   rst_exists: std_logic := '1';
   ld_exists: std_logic := '0';
   ctype: integer := 2;
   ival: integer := 0;
   tval: integer := 127;
   bitwidth : integer := 16;
   isSigned: std_logic := '0'
);
port (
  clk: in std_logic;
  en: in std_logic;
  grst: in std_logic;
  rst: in std_logic;
  up: in std_logic;
  ld: in std_logic;
  din: in std_logic_vector(bitwidth-1 downto 0);
  cnt: out std_logic_vector(bitwidth-1 downto 0)
);
end synCounterFRMC;

architecture behav of synCounterFRMC is

type cntTypeU is array (0 to ch_no-1) of unsigned(bitwidth-1 downto 0);
signal cntsU : cntTypeU;
type cntTypeS is array (0 to ch_no-1) of signed(bitwidth-1 downto 0);
signal cntsS : cntTypeS;

begin
  usig: if (isSigned = '0')
    generate
      countU: process(clk)
      begin
        if(rising_edge(clk)) then
         if(grst='1') then
           cntsU <= (others => to_unsigned(ival, bitwidth));        
         else
          if(rst='1' and rst_exists='1') then
            cntsU(0) <= to_unsigned(ival, bitwidth); 
          elsif(en='1' or en_exists='0') then
            if(ld='1' and ld_exists='1') then
        cntsU(0) <= unsigned(din);
      else
        if(ctype=1) then          
          if(up='1') then
                  cntsU(0) <= cntsU(ch_no-1) + 1;
          else
                  cntsU(0) <= cntsU(ch_no-1) - 1;
        end if;
        elsif(ctype=2) then
                cntsU(0) <= cntsU(ch_no-1) + 1;
        else
                cntsU(0) <= cntsU(ch_no-1) - 1;
        end if;
            end if;
      else
            cntsU(0) <= cntsU(ch_no-1);
          end if;
      
      for i in ch_no-1 downto 1 loop
        cntsU(i) <= cntsU(i-1);
      end loop;
         end if;
        end if;
      end process;
      cnt <= std_logic_vector(cntsU(ch_no-1));
    end generate;

  sig: if (isSigned = '1')
    generate
      countS: process(clk)
      begin
        if(rising_edge(clk)) then
         if(grst='1') then
           cntsS <= (others => to_signed(ival, bitwidth));        
         else
          if(rst='1' and rst_exists='1') then
            cntsS(0) <= to_signed(ival, bitwidth); 
          elsif(en='1' or en_exists='0') then
            if(ld='1' and ld_exists='1') then
        cntsS(0) <= signed(din);
      else
        if(ctype=1) then          
          if(up='1') then
                  cntsS(0) <= cntsS(ch_no-1) + 1;
          else
                  cntsS(0) <= cntsS(ch_no-1) - 1;
          end if;
        elsif(ctype=2) then
                cntsS(0) <= cntsS(ch_no-1) + 1;
        else
                cntsS(0) <= cntsS(ch_no-1) - 1;
        end if;
      end if;
      else
            cntsS(0) <= cntsS(ch_no-1);
          end if;
      
      for i in ch_no-1 downto 1 loop
        cntsS(i) <= cntsS(i-1);
      end loop;
         end if;
        end if;
      end process;
      cnt <= std_logic_vector(cntsS(ch_no-1));
    end generate;

end behav;

-------------------------------
--Accumulator_MC block is modified to read output from the adder output
--instead of register output as it was in pre-modified version

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity synAccumulatorMC is
generic(
   ch_no : integer := 64;
   bitwidth : integer := 16;
   datatype: string := "signed";
   opr: string := "+="
);
port (
  clk: in std_logic;
  inp: in std_logic_vector(bitwidth-1 downto 0);
  genab: in std_logic;
  grst: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synAccumulatorMC;

architecture behav of synAccumulatorMC is
type accUType is array (0 to ch_no-1) of unsigned(bitwidth-1 downto 0);
signal accU : accUType;
type accSType is array (0 to ch_no-1) of signed(bitwidth-1 downto 0);
signal accS : accSType;
signal addOutS : signed(bitwidth-1 downto 0);
signal addOutU : unsigned(bitwidth-1 downto 0);

begin
  sig: if (datatype = "signed")
    generate
      accprocsig: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            for i in ch_no-1 downto 0 loop
              accS(i) <= to_signed(0, bitwidth);
            end loop;
          elsif(genab='1') then
            if(rst='1') then
              accS(0) <= to_signed(0, bitwidth);
            elsif(en='1') then
              accS(0) <= addOutS;
            else
              accS(0) <= accS(ch_no-1);
            end if;
            for i in ch_no-1 downto 1 loop
              accS(i) <= accS(i-1);
            end loop;
          end if;
        end if;
      end process;

    
    addOutS <= accS(ch_no-1) + signed(inp) when opr ="+=" else
                 accS(ch_no-1) - signed(inp);
    
    outp <= std_logic_vector(accS(ch_no-1));

  end generate;

  uns: if (datatype = "unsign")
    generate
      accprocuns: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            for i in ch_no-1 downto 0 loop
              accU(i) <= to_unsigned(0, bitwidth);
            end loop;
          elsif(genab='1') then
            if(rst='1') then
              accU(0) <= to_unsigned(0, bitwidth);
            elsif(en='1') then
              accU(0) <= addOutU;
            else
              accU(0) <= accU(ch_no-1);
            end if;
            for i in ch_no-1 downto 1 loop
              accU(i) <= accU(i-1);
            end loop;
          end if;
        end if;
      end process;

    addOutU <= accU(ch_no-1) + unsigned(inp) when opr ="+=" else
                 accU(ch_no-1) - unsigned(inp);
    
    outp <= std_logic_vector(accU(ch_no-1));

  end generate;
  
end behav;

-------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synAccumulatorMCOvf is
generic(
   ch_no : integer := 64;
   bitwidth : integer := 16;
   datatype: string := "signed";
   opr: string := "+="
);
port (
  clk: in std_logic;
  inp: in std_logic_vector(bitwidth-1 downto 0);
  genab: in std_logic;
  grst: in std_logic;
  en: in std_logic;
  rst: in std_logic;
  ovf: out std_logic;
  outp: out std_logic_vector(bitwidth-1 downto 0)
);
end synAccumulatorMCOvf;

architecture behav of synAccumulatorMCOvf is
type accUType is array (0 to ch_no-1) of unsigned(bitwidth-1 downto 0);
signal accU : accUType;
type accSType is array (0 to ch_no-1) of signed(bitwidth-1 downto 0);
signal accS : accSType;
signal addOutS : signed(bitwidth-1 downto 0);
signal addOutU : unsigned(bitwidth downto 0);
signal ovfReg: std_logic_vector(0 to ch_no-1);
signal ovfLine: std_logic;

begin
  sig: if (datatype = "signed")
    generate
      accprocsig: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            for i in ch_no-1 downto 0 loop
              accS(i) <= to_signed(0, bitwidth);
        ovfReg(i) <= '0';
            end loop;
          elsif(genab='1') then
            if(rst='1') then
              accS(0) <= to_signed(0, bitwidth);
        ovfReg(0) <= '0';
            elsif(en='1') then
              accS(0) <= addOutS;
        ovfReg(0) <= ovfLine;
            else
              accS(0) <= accS(ch_no-1);
        ovfReg(0) <= ovfReg(ch_no-1);
            end if;
            for i in ch_no-1 downto 1 loop
              accS(i) <= accS(i-1);
        ovfReg(i) <= ovfReg(i-1);
            end loop;
          end if;
        end if;
      end process;

    
    addOutS <= accS(ch_no-1) + signed(inp) when opr ="+=" else
                 accS(ch_no-1) - signed(inp);
    ovfLine <= '1' when ((opr = "+=" and accS(ch_no-1)(bitwidth-1) = inp(bitwidth-1)) or 
                         (opr = "-=" and accS(ch_no-1)(bitwidth-1) /= inp(bitwidth-1))) and
                         (addOutS(bitwidth-1) /= accS(ch_no-1)(bitwidth-1)) else '0';
    
    outp <= std_logic_vector(accS(ch_no-1));
  ovf <= ovfReg(ch_no-1);

  end generate;

  uns: if (datatype = "unsign")
    generate
      accprocuns: process(clk)
      begin
        if(rising_edge(clk)) then
          if(grst='1') then
            for i in ch_no-1 downto 0 loop
              accU(i) <= to_unsigned(0, bitwidth);
        ovfReg(i) <= '0';
            end loop;
          elsif(genab='1') then
            if(rst='1') then
              accU(0) <= to_unsigned(0, bitwidth);
        ovfReg(0) <= '0';
            elsif(en='1') then
              accU(0) <= syn_resize(addOutU, bitwidth);
        ovfReg(0) <= ovfLine;
            else
              accU(0) <= accU(ch_no-1);
        ovfReg(0) <= ovfReg(ch_no-1);
            end if;
            for i in ch_no-1 downto 1 loop
              accU(i) <= accU(i-1);
        ovfReg(i) <= ovfReg(i-1);
            end loop;
          end if;
        end if;
      end process;

    addOutU <= syn_resize(accU(ch_no-1),bitwidth+1) + syn_resize(unsigned(inp),bitwidth+1) 
             when opr ="+=" else
               syn_resize(accU(ch_no-1),bitwidth+1) - syn_resize(unsigned(inp),bitwidth+1);
    ovfLine <= addOutU(bitwidth);
  ovf <= ovfReg(ch_no-1);
    outp <= std_logic_vector(accU(ch_no-1));

  end generate;
  
end behav;

------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library SynDspLib;
use SynDspLib.synLibFunctions.all;

entity synFIFO_MC is
generic(
   ch_no    : integer := 2;
   st_width : integer := 1;
   bitwidth : integer := 16;
   depth    : integer := 16;
   cntwidth : integer := 5;
   adrWidth : integer := 4
);
port (
  clk: in std_logic;
  st: in unsigned (st_width-1 downto 0);
  din: in std_logic_vector(bitwidth-1 downto 0);
  we: in std_logic;
  re: in std_logic;	
  grst: in std_logic;
  rst: in std_logic;
  dout: out std_logic_vector(bitwidth-1 downto 0);
  full: out std_logic;
  empty: out std_logic;
  itemcnt: out std_logic_vector(cntwidth-1 downto 0)
);
end synFIFO_MC;

architecture behav of synFIFO_MC is

signal wes: std_logic_vector(0 to ch_no-1);
signal res: std_logic_vector(0 to ch_no-1);
signal rsts: std_logic_vector(0 to ch_no-1);
signal fuls: std_logic_vector(0 to ch_no-1);
signal emps: std_logic_vector(0 to ch_no-1);

type bufType is array (0 to ch_no-1) of std_logic_vector(bitwidth-1 downto 0);
signal outbuf : bufType;

type icsType is array (0 to ch_no-1) of std_logic_vector(cntwidth-1 downto 0);
signal ics : icsType;

-----

begin

  dout <= outbuf(to_integer(st));
  full <= fuls(to_integer(st));
  empty <= emps(to_integer(st));
  itemcnt <= ics(to_integer(st));

  chs: for j in 0 to ch_no-1 generate
    
    wes(j) <= '1' when st = to_unsigned(j, st_width) and we = '1' else
              '0';

    res(j) <= '1' when st = to_unsigned(j, st_width) and re = '1' else
              '0';

    rsts(j) <= '1' when st = to_unsigned(j, st_width) and rst = '1' else
              '0';

    tch: synFIFO
    generic map(
      bitwidth => bitwidth,
    depth => depth,
    cntwidth => cntwidth,
    adrWidth => adrWidth
    )
    port map(
      clk=>clk,
      din=>din,
      we=>wes(j),
      re=>res(j),  
	  grst=>grst,
      rst=>rsts(j),
    full=>fuls(j),
    empty=>emps(j),
    dout=>outbuf(j),
    itemcnt=>ics(j)
    );
  end generate chs;
  
end behav;











