-------------------------------------------------------------------------------------
-- Entity:	DX64_cicb
--
-- Project:	Uni1p
--
-- Author:	Antonin Hegar
--
-- Description:
--	Top entity of XC2V250 on DX64 v1.0
--
-- Revision:
--	$Log: DX64_cicb.vhd,v $
--	Revision 1.1  2006/05/05 17:05:50  Tony
--	Initial version.
--	Entity to test CiCb.
--	
--
-------------------------------------------------------------------------------------

-------------------------------------------------------------------------------------
-- LIBRARY
-------------------------------------------------------------------------------------
library ieee;
library unisim;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.DX64Header.all;
use work.MathLib.all;
use unisim.vcomponents.all;

-------------------------------------------------------------------------------------
-- ENTITY
-------------------------------------------------------------------------------------
entity DX64_sobel is
	port (
      clk : in std_logic;
      rst : in std_logic;
      ena :  in std_logic;
      data_out :  out std_logic_vector(15 downto 0); 
      data_in :  in std_logic_vector(7 downto 0) 	
	);
end entity DX64_sobel;


-------------------------------------------------------------------------------------
-- ENTITY
-------------------------------------------------------------------------------------
architecture Struct of DX64_sobel is


-- Definition of sobel_wr interface
  component sobel_wr is
   port( 
      clk : in std_logic;
      rst : in std_logic;
      ena :  in std_logic;
      data_out :  out std_logic_vector(15 downto 0); 
      data_in :  in std_logic_vector(7 downto 0) 
	);
  end component;

      
begin




	inst_sobel_wr: sobel_wr port map(
		  clk => clk,
      rst => rst,
      ena => ena,
      data_out => data_out,
      data_in => data_in
	);

end architecture;
